

#ifndef PrefiM_BSP_H__
#define PrefiM_BSP_H__

#include <stdint.h>

#define PIN_BreakerOut			30 //2
#define PIN_BreakerSense		31 //3
#define PIN_LoadDetectOut		29 //4
#define PIN_LoadDetectSense	28 //5

#define PIN_Magnet					15 //11
#define PIN_TAMPER					17 //31

#define PIN_LedR						12 //16
#define PIN_LedG						13 //17
#define PIN_LedB						14 //18

#define PIN_SDA							20
#define PIN_SCL							21

#define PIN_SPEAKER					19 //5
#define PIN_AudioSHDN				18 //4

#define PIN_TxD							23
#define PIN_RxD							24

#define PIN_AccelINT				25 //28
#define PIN_VMONext					30

#define PIN_PRODTEST				27 //29

#define PIN_DIP_1						2 //6
#define PIN_DIP_2						3 //7
#define PIN_DIP_3						4 //8
#define PIN_DIP_4						5 //12
#define PIN_DIP_5						6 //13
#define PIN_DIP_6						7 //14
#define PIN_DIP_7						8 //15
#define PIN_DIP_8						11 //19

#define PIN_VCC_HALL				16
#define PIN_VCC_I2CEN				22
#define PIN_MODESELECT			26

#define BSP_LED_R_MASK (1<<PIN_LedR)
#define BSP_LED_G_MASK (1<<PIN_LedG)
#define BSP_LED_B_MASK (1<<PIN_LedB)

static const uint8_t m_android_package_name[] = {'s', 'e', '.', 'c', 'a', 'b', 'i', 'n', 'o', 'v',
                                                 'a', '.', 's', 't', 'o', 'v', 'e', 'g', 'u', 'a',
                                                 'r', 'd', 's', '.', 'a', 'p', 'p'};

void beep(void);
void PMBSP_set_leds(uint8_t R_PWM, uint8_t G_PWM, uint8_t B_PWM, uint8_t blink_status);
void PMBSP_IO_init(void);
void PMBSP_update_sound(uint8_t duty_cycle, uint16_t frequency);
void PMBSP_saadc_init(void);
void PMBSP_NFC_init(void);
uint8_t PMBSP_read_DIP(void);
int8_t  PMBSP_readtemperature(void);
uint8_t PMBSP_set_contactor(unsigned char timeout);
uint8_t PMBSP_release_contactor(unsigned char timeout);
uint8_t PMBSP_read_Prodtest(void);
uint8_t PMBSP_read_Magnet(void);
uint8_t PMBSP_read_Tamper(void);
	
#endif
