// Prefi M Global Variables

#include <stdint.h>
#include "globals.h"
#include "ble_sghs.h"
#include "ble_sgis.h"
#include "ble_sgss.h"
#include "ble_sgds.h"
#include "ble_bas.h"
#include "ble_dis.h"

uint8_t runmode;
uint8_t DIP_Smart_timer;				   // TRUE = Smart timer
uint8_t DIP_Regular_timer;				// TRUE = Regular timer
uint32_t DIP_Timer;								// TRUE = Regular timer

uint8_t DIP_Boiler; 					// TRUE = Boiler temperature limit function on
uint8_t DIP_Sound_warning; 		// TRUE = Sound signal on  
uint8_t DIP_LED_Indicator; 		// TRUE = LED indicators on
uint8_t DIP_use_Indicator; 		// TRUE = Summer useage indicator on
uint8_t DIP_MagnetControlled; // TRUE = Magnetkontrollerad brytare

uint16_t m_conn_handle; // Handle of the current BLE connection
uint16_t m_conn_handle_peripheral_0;
ble_sgis_t * p_sgis_main;

ble_bas_t m_bas;		// Structure used to identify the battery service
ble_sghs_t m_sghs;	// Main structures used by the Stove Guard Hardware service
ble_sgis_t m_sgis;	// Main structures used by the Stove Guard Installation test service
ble_sgss_t m_sgss;	// Main structures used by the Stove Guard Security service
ble_sgds_t m_sgds;	// Main structures used by the Stove Guard Detector service

char BLE_connected_flag;

//char sleep_mode;

unsigned char mainstate = STARTUP;				// Main State Machine

signed short SensorImage[NUMBER_OF_ROWS][PIX_PER_ROW]; // 2x32x32 = 2k

// Global softtimers
volatile uint8_t timer_magnetkey_running;
volatile uint32_t runtime_magnetkey;

volatile uint8_t timer_alarm_delay_running;
volatile uint32_t runtime_alarm_delay;

volatile uint8_t timer_movement_delay_running;
volatile uint32_t runtime_movement_delay;

volatile uint8_t timer_stove_running;
volatile uint32_t runtime_stove;

volatile uint8_t timer_sgisTest_running;
volatile uint32_t runtime_sgisTest;

volatile uint8_t timer_kontaktor_running;
volatile uint32_t runtime_kontaktor;

unsigned char timer_rest_running;
unsigned volatile int runtime_rest;

volatile uint8_t timer_advertising_running;
volatile uint32_t runtime_advertising;



signed short SensorImage_Hist_1s[NUMBER_OF_ROWS][PIX_PER_ROW]; // 2x32x32 = 2k

uint8_t TEMPERATURE_STATUS;
uint8_t SENSESTATE_OUTPUT;

uint8_t SOMEONE_PRESENT_FLAG;
uint8_t MOVEMENT_FLAG;
uint8_t MOVEMENT_ON_STOVE;
uint8_t SENSESTATE_STATUS;

char resultOfTemperatureAnalysis;

char movementOnStoveFlag;
//int minimumOfHumanPixels;

locationStruct hotestTemperatureHistogram_10s[10];
char whenToSaveHotestTemperatureCounter;
//**************************************Powersave*************************************************************************************************
uint8_t blockToRead;
char sensorReadoutMode;


locationStruct areasOfInterest[32]; 
locationStruct areasOfInterest_Hist_1s[32];



int whenToMakeSoundIndication;
int whenToFlash;

//Global variables for external units
signed short TaSensor;								//Sensortemperature
int16_t acc_x;															//accelerometer x value
int16_t acc_y;															//accelerometer y value
int16_t acc_z;															//accelerometer z value

short hotestTemperature;
//**************************************MAINSTATEMACHINE*************************************************************************************************/
uint8_t MAGNETSTATUS;
uint8_t DIPstatus;
uint8_t warningLevelSound;
uint8_t warningLevelVisual;
uint8_t cutPowerLevel;
int numberOfTimerBreaks;
int numberOfOverheatBreaks;
uint8_t powerConsumtionBreaker[4];
//extern unsigned char mainstate;				// Main State Machine
//**************************************POWER SENSE*************************************************************************************************/
unsigned int KONTAKTOR_WaitTime; // 0 -> 255 sekunders paus mellan belastningskollarna
unsigned int PREREST_WaitTime; // 0 -> 255 sekunders paus innan vi brjar kolla belastning
unsigned volatile char PowerMeasureLoadOn;
unsigned volatile char load_sense_counter;
unsigned volatile char PowerMeasurePeriod;
unsigned volatile char PowerMeasureStatus;
unsigned volatile char load_is_on;
 unsigned volatile int load_hist_time_off;
 unsigned volatile int load_sense_timer;
 unsigned volatile char load_off_valid;
unsigned volatile int load_hist_time_on;
unsigned int load_sense_waittimer;
unsigned volatile char load_on_valid;
unsigned volatile char LOAD_SENSE_PIN;
uint16_t activePowerConsumtionBreaker;
uint16_t reactivePowerConsumtionBreaker;
char powerMode;

unsigned char load_type;
unsigned char last_load_type;

unsigned char loadstate;			// Tillstndsmaskin fr lastidentifiering

unsigned volatile char BELASTNING_STATUS;

unsigned int MAXRUNTIME;


