// Prefi M Application main file.

#define NRF_LOG_MODULE_NAME "APP"
#include "globals.h"
#include "nrf_drv_gpiote.h"
#include "nrf_delay.h"
#include "nrf_log.h"
#include "nrf_log_ctrl.h"

#include "m_DebugUart.h"
#include "BLE_middleware.h"
#include "m_ApplicationInit.h"
#include "m_ApplicationTimers.h"
#include "m_ApplicationInterface.h"

#include "PrefiM_bsp.h"
#include "nrf_soc.h"
#include "nrf_drv_clock.h"
#include "nrf_uart.h"

#include "MMA8652FC.h"
//#include "arm_const_structs.h"

#include <stdio.h>

#define FPU_EXCEPTION_MASK               0x0000009F      


int main(void)
{
	short whenToUpdateSensorDataCounter = 0;
	
	uint8_t TAMPERSTATUS;
	//uint8_t DIPstatus;  //This variable is moved to globals.h
	//uint32_t irqresult;
	ret_code_t err_code;
	//Nolla variabler
	numberOfTimerBreaks = 0;
  numberOfOverheatBreaks = 0;
	whenToMakeSoundIndication = 255;
	runmode = 0;
	
	 m_conn_handle_peripheral_0= BLE_CONN_HANDLE_INVALID;
	m_conn_handle = BLE_CONN_HANDLE_INVALID;
	// **********  Lgnivinitiering  **********
	
	err_code = nrf_drv_clock_init();
	nrf_drv_clock_lfclk_request(NULL);
	
	
	//****************************************************************************************************
	//This will be set by different hardware configuration in the future. 
	#ifdef WIRELESS
	PMBLE_ble_stack_init();				// Starta Softdevice, mste ske frst d mnga events passerar den...
	PMAI_ble_init();							// Stt upp BLE, brja svara p services men starta ingen advertising
	PMBLE_advertising_start(0);	// Start advertizing
	#endif
	
	//PMDEBUG_uart_init();					// Starta Debug Uart (trdbunden, OBS! 921600bps 8,1,n)
	//PMAI_log_init(); 							// Starta nrf LOG fr applikationsloggning
	//NRF_LOG_INFO("Prefi M initialized and started.\r\n");
 //NRF_LOG_FLUSH();
	PMBSP_IO_init(); 							// Stt upp hrda interrupt frn ingngar (Magnet, Tamper, DIP etc) + stt utgngar i startuplge
	PMAIF_LED_Set(ALL_OFF,SOLID);
	PMAI_variable_init();
	//nrf_gpio_pin_clear(PIN_VCC_I2CEN);
	//nrf_delay_ms(5);
	//PMAI_twi_init(); 							// Starta I2C (bussniv) //Moved
	



	PMAT_timers_init();						// App timers mste startas innan BLE!



	
	while(1)
  {
	
 
	
	
		PMAIF_LED_Set(RED,SOLID);
		nrf_delay_ms(500);
		PMAIF_LED_Set(ALL_OFF,SOLID);
		nrf_delay_ms(500);
	}
}

