#include "app_twi.h"
#include "PrefiM_bsp.h"
#include "nrf_log.h"
#include "nrf_log_ctrl.h"
#include "HTPA32x32.h"
#include "ble_middleware.h"
#include "MMA8652FC.h"
#include "globals.h"
#include "m_ApplicationInterface.h"


/* TWI instance ID. */
#define TWI_INSTANCE_ID	0
/* TWI instance. */
#define MAX_PENDING_TRANSACTIONS    5
APP_TWI_DEF(m_app_twi, MAX_PENDING_TRANSACTIONS, TWI_INSTANCE_ID);


void PMAI_ble_init(void)
{
	PMBLE_gap_params_init();		// This function sets up all the necessary GAP (Generic Access Profile) parameters of the device including the device name, appearance, and the preferred connection parameters
	PMBLE_gatt_init(); 					// Function for initializing the GATT module
	PMBLE_advertising_init(); 	// Function for initializing the Advertising functionality
	PMBLE_services_init();			// Function for initializing services that will be used by the application
//    sensor_simulator_init();
	PMBLE_conn_params_init(); 	// Function for initializing the Connection Parameters module
  PMBLE_peer_manager_init(); 	// Function for the Peer Manager initialization
}


void PMAI_variable_init(void)
{
		//egentligen ingen riktig timer men anvnds som en timer i alla fall:). Triggas av belastnignen
	load_sense_counter = 0;
	PowerMeasurePeriod = 0;
	PowerMeasureStatus = FALSE;
	load_hist_time_off = 0;
	load_sense_timer = 0;
	load_hist_time_on = 0;
	//load_on_valid = TRUE;
	loadstate = LS_STARTUP;
	mainstate = STARTUP;		
	LOAD_SENSE_PIN = 0;
	BLE_connected_flag = false;			//Flag that tells the mainprogram if we have an connection or not.
	
	whenToSaveHotestTemperatureCounter = 0;
	
	//sleep_mode = SLEEP_MODE_ONE;
	
	blockToRead = 0;								//which bloch should be read if we only read one block. 
	sensorReadoutMode = SENSOR_READOUT_NORMAL_MODE;			//NORMAL_MODE = read complete sensor
	powerMode = POWER_MODE_1s;

}	


/**@brief Function for initializing the nrf log module.
 */
void PMAI_log_init(void)
{
    ret_code_t err_code = NRF_LOG_INIT(NULL);
    APP_ERROR_CHECK(err_code);
}

void PMAI_saadc_init(void)
{
//    saadc_init();
//		saadc_sampling_event_init();
//		nrf_drv_saadc_calibrate_offset();
//		saadc_sampling_event_enable();
}

//   APP_ERROR_CHECK(app_twi_perform(&m_app_twi, MMA8652_init_device, MMA8652_INIT_TRANSFER_COUNT, NULL));

void PMAI_TWIdevices_init(void)
{
	PMAIF_StartI2C();
	
	HTPA32x32_init_sensor();
	MMA8652_init_accelerometer();
	
	PMAIF_StopI2C();
}

/**
 * @brief TWI (I2C) initialization.
 */
void PMAI_twi_init (void)
{

	
    ret_code_t err_code;

    const nrf_drv_twi_config_t twi_I2C_config = {
       .scl                = PIN_SCL,
       .sda                = PIN_SDA,
       .frequency          = NRF_TWI_FREQ_250K,
       .interrupt_priority = APP_IRQ_PRIORITY_HIGH,
       .clear_bus_init     = true,
			 .hold_bus_uninit		 = true
    };

//    err_code = nrf_drv_twi_init(&m_twi, &twi_I2C_config, twi_handler, NULL);
		err_code = app_twi_init(&m_app_twi, &twi_I2C_config);
    APP_ERROR_CHECK(err_code);

    //nrf_drv_twi_enable(&m_twi);
}
void PMAI_twi_uninit (void)
{
    ret_code_t err_code;
		
		app_twi_uninit(&m_app_twi);
	
		
	}

//	  // Set up NFC 
//    err_code = nfc_t2t_setup(nfc_callback, NULL);
//    APP_ERROR_CHECK(err_code);

//		// Provide information about available buffer size to encoding function.
//    len = sizeof(m_ndef_msg_buf);
//		
//    // Encode text message 
////    text_msg_encode(m_ndef_msg_buf, &len);

//    // Encode launchapp message into buffer 
//    err_code = nfc_launchapp_msg_encode(m_android_package_name,
//                                        sizeof(m_android_package_name),
//                                        NULL,
//                                        0,
//                                        m_ndef_msg_buf,
//                                        &len);

//    APP_ERROR_CHECK(err_code);


//    // Set created message as the NFC payload
//    err_code = nfc_t2t_payload_set(m_ndef_msg_buf, len);
//    APP_ERROR_CHECK(err_code);

//    // Start sensing NFC field
//    err_code = nfc_t2t_emulation_start();
//    APP_ERROR_CHECK(err_code);
