#include <stdint.h>
#include "PrefiM_bsp.h"
#include "globals.h"
#include "led_softblink.h"
#include "ble_sghs.h"
#include "nrf_delay.h"
#include "m_ApplicationInit.h"

void PMAIF_DisableStove(void)
{
	uint8_t breakerState;
	
	breakerState = 0;//RELEASE_BREAKER;
	
	ble_sghs_on_bstat_change(m_conn_handle,&m_sghs, breakerState);
	PMBSP_release_contactor(0);
	//PMBSP_set_contactor(0);
}

void PMAIF_EnableStove(void)
{
	uint8_t breakerState;
	
	breakerState = 1;//PULL_BREAKER;
	
	ble_sghs_on_bstat_change(m_conn_handle,&m_sghs, breakerState);
	//ble_sghs_on_mkey_change(m_conn_handle,&m_sghs, breakerState);
	
	PMBSP_set_contactor(0);									//Pull relay
	
	
	

	//PMBSP_release_contactor(0);
}

void PMAIF_SUMMER_Set(uint8_t mode)
{
	beep(); // Fixas till nt bttre...
}

static void blink_LED_Set(uint8_t RGBmode, uint8_t flashmode, uint8_t lastRGBmode, uint8_t lastflashmode)
{
	static uint8_t initialized = false;
	ret_code_t err_code;
	led_sb_init_params_t led_sb_init_param; // = LED_SB_INIT_DEFAULT_PARAMS(BSP_LED_R_MASK);
	
	led_sb_init_param.active_high = true;
	led_sb_init_param.duty_cycle_max = 255;
	led_sb_init_param.duty_cycle_min = 0;
	led_sb_init_param.duty_cycle_step = 5;
	led_sb_init_param.off_time_ticks = 65536;
	led_sb_init_param.on_time_ticks = 0;
	led_sb_init_param.leds_pin_bm = 1; // BSP_LED_R_MASK; // | BSP_LED_G_MASK | BSP_LED_B_MASK;
	led_sb_init_param.p_leds_port = NRF_P0;
	
	if (!initialized)												// Verkar vara frsta gngen vi startar
	{
	  err_code = led_softblink_init(&led_sb_init_param);
		APP_ERROR_CHECK(err_code);
		initialized = true;
	}
	
	if (lastflashmode != SOLID)
	{
		err_code = led_softblink_stop();
		APP_ERROR_CHECK(err_code);
	}
	
	switch(flashmode)
	{
		case SLOW_BLINK:
			led_softblink_off_time_set(65536);
			led_softblink_on_time_set(0);
		break;

		case FAST_BLINK:
			led_softblink_off_time_set(5000);
			led_softblink_on_time_set(0);
		break;
	}	
	
	switch(RGBmode)
	{
		case RED:
			err_code = led_softblink_start(BSP_LED_R_MASK);
		break;

		case GREEN:
			err_code = led_softblink_start(BSP_LED_G_MASK);
		break;

		case BLUE:
			err_code = led_softblink_start(BSP_LED_B_MASK);
		break;

		case MAGENTA:
			err_code = led_softblink_start(BSP_LED_R_MASK | BSP_LED_B_MASK);
		break;

		case YELLOW:
			err_code = led_softblink_start(BSP_LED_R_MASK | BSP_LED_G_MASK);
		break;
		
		case CYAN:
			err_code = led_softblink_start(BSP_LED_G_MASK | BSP_LED_B_MASK);
		break;

		case WHITE:
			err_code = led_softblink_start(BSP_LED_R_MASK | BSP_LED_G_MASK | BSP_LED_B_MASK);
		break;
		
		default:
		break;
	}
}

void PMAIF_LED_Set(uint8_t RGBmode, uint8_t flashmode)
{
	static uint8_t lastRGBmode = ALL_OFF;
	static uint8_t lastflashmode = SOLID;
	
	ret_code_t err_code;


	if( (RGBmode == lastRGBmode) & (flashmode == lastflashmode) )		// Nya instllningen r samma som den som redan krs,
		return;																												// s vi kan returnera direkt
	
//	beep();

	if (flashmode == SOLID)
	{
		if (lastflashmode != SOLID)							// Vi hll p och blinkade... sluta med det
		{
				err_code = led_softblink_stop();
				APP_ERROR_CHECK(err_code);
		}

		switch(RGBmode)
		{
			case ALL_OFF:
				nrf_gpio_pin_clear(PIN_LedR);
				nrf_gpio_pin_clear(PIN_LedG);
				nrf_gpio_pin_clear(PIN_LedB);
			break;
			
			case RED:
				nrf_gpio_pin_set(PIN_LedR);
				nrf_gpio_pin_clear(PIN_LedG);
				nrf_gpio_pin_clear(PIN_LedB);
			break;

			case GREEN:
				nrf_gpio_pin_clear(PIN_LedR);
				nrf_gpio_pin_set(PIN_LedG);
				nrf_gpio_pin_clear(PIN_LedB);
			break;

			case BLUE:
				nrf_gpio_pin_clear(PIN_LedR);
				nrf_gpio_pin_clear(PIN_LedG);
				nrf_gpio_pin_set(PIN_LedB);
			break;

			case MAGENTA:
				nrf_gpio_pin_set(PIN_LedR);
				nrf_gpio_pin_clear(PIN_LedG);
				nrf_gpio_pin_set(PIN_LedB);
			break;

			case YELLOW:
				nrf_gpio_pin_set(PIN_LedR);
				nrf_gpio_pin_set(PIN_LedG);
				nrf_gpio_pin_clear(PIN_LedB);
			break;
			
			case CYAN:
				nrf_gpio_pin_clear(PIN_LedR);
				nrf_gpio_pin_set(PIN_LedG);
				nrf_gpio_pin_set(PIN_LedB);
			break;

			case WHITE:
				nrf_gpio_pin_set(PIN_LedR);
				nrf_gpio_pin_set(PIN_LedG);
				nrf_gpio_pin_set(PIN_LedB);
			break;
			
			default:
			break;
		}	
	}
	else
	{
		if (lastflashmode == SOLID)
		{
			nrf_gpio_pin_clear(PIN_LedR);
			nrf_gpio_pin_clear(PIN_LedG);
			nrf_gpio_pin_clear(PIN_LedB);
		}
		
		blink_LED_Set(RGBmode, flashmode, lastRGBmode, lastflashmode);
	}
	
	lastRGBmode = RGBmode;				// Spara undan aktuella instllningar tills nsta gng LED:en ev. skall ndras
	lastflashmode = flashmode;
}

uint8_t PMAIF_TamperActive(void)
{

	if (PMBSP_read_Tamper() == TRUE)
		return TRUE;
	else
		return FALSE;

}
void PMAIF_StartI2C(void)
{
	nrf_gpio_pin_clear(PIN_VCC_I2CEN);
	nrf_delay_ms(10);
	PMAI_twi_init();
	nrf_delay_ms(10);
}
void PMAIF_StopI2C(void)
{
	nrf_delay_ms(10);
	HTPA32x32_stopSensor();	
	PMAI_twi_uninit();
	nrf_delay_ms(100);

	
	nrf_gpio_pin_set(PIN_VCC_I2CEN);
/*		nrf_gpio_cfg_output(PIN_SDA);
	nrf_gpio_cfg_output(PIN_SCL);
	nrf_gpio_pin_set(PIN_SDA);
		nrf_gpio_pin_clear(PIN_SDA);
	nrf_gpio_pin_clear(PIN_SDA);
	nrf_delay_ms(20);
	
		nrf_gpio_pin_set(PIN_SDA);
	
	nrf_gpio_pin_set(PIN_SCL);
*/
	//nrf_delay_ms(100);
	nrf_delay_ms(10);
}
	