#include "nrf_delay.h"

#include <stdio.h>

#include "app_uart.h"

#include "globals.h"
#include "PrefiM_bsp.h"
//#include "HTPA32x32.h"
//#include "m_MainStateMachine.h"
//#include "m_SenseStateMachine.h"
//#include "m_SensorProcessing.h"

#define UART_TX_BUF_SIZE 512                                                          /**< UART TX buffer size. */
#define UART_RX_BUF_SIZE 128                                                            /**< UART RX buffer size. */

static void VT100_erasescreen(void)
{
	putchar(27);
	putchar('[');
	putchar('2');
	putchar('J');
}

/********************************************************************
 * Function:        
 *
 * Description:     
 *
 * Dependencies:    
 *							
 *******************************************************************/
void PMDEBUG_debugprint_temp(void)
{
	unsigned char i,j;

	static unsigned long loopno = 0;
	
	putchar(27);
	putchar('[');
	putchar('H');
	
	printf("\r\n-- Temperature data start --\r\n");
	
	for (i = 0; i < 32; i++)
	{
		
		for (j = 0; j < 32; j++)
		{	
			printf("%d ",SensorImage[i][j]);
//			nrf_delay_us(100);
		}
		
		printf("\r\n");	
	}
	
	printf("-- Temperature data end -- Frame: %lu\r\n",loopno++);
}

void PMDEBUG_debugprint_states(void)
{
		//printf("MainState: %d, ",MSM_GetState());
	//printf("SenseState: %d\r\n",SSM_GetState());
	printf("xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\n");
}
void PMDEBUG_debugprint_globals(void)
{
	printf("\r\n");

	printf("Software status  :     ");
	//printf("MainState: %d, ",MSM_GetState());
	//printf("SenseState: %d\r\n",SSM_GetState());

	printf("IO status        :     ");
	printf("DIP_Boiler: %d, ", DIP_Boiler);
	printf("DIP_Sound_warning: %d, ", DIP_Sound_warning);
	printf("DIP_LED_Indicator: %d, ", DIP_LED_Indicator);
	printf("DIP_use_Indicator: %d, ", DIP_use_Indicator);
	printf("DIP_MagnetControlled: %d\r\n", DIP_MagnetControlled);
	printf("                       ");
	printf("Producion test: %d, ",PMBSP_read_Prodtest());
	printf("Front Magnet: %d, ", PMBSP_read_Magnet());
	printf("Tamper Magnet: %d\r\n", PMBSP_read_Tamper());

	printf("Hardware status  :     ");
	printf("CPU Temp: %3d\r\n",PMBSP_readtemperature());
	
	printf("IR Sensor status :     ");
	printf("MAX Temp: %3d deg. C\r\n",SP_MaxTemperature());
}

void PMDEBUG_debugsensor(void)
{
	//HTPA32x32_readCompleteSensor();
	PMDEBUG_debugprint_temp();		// OBS! Sl av NRF_logging i sdk_config, annars krockar utskrifterna...
	PMDEBUG_debugprint_globals();
}

/**
 * @brief UART events handler.
 */
/* static void uart_events_handler(app_uart_evt_t * p_event)
{
    switch (p_event->evt_type)
    {
        case APP_UART_COMMUNICATION_ERROR:
            APP_ERROR_HANDLER(p_event->data.error_communication);
            break;

        case APP_UART_FIFO_ERROR:
            APP_ERROR_HANDLER(p_event->data.error_code);
            break;

        default:
            break;
    }
}
*/
static void uart_error_handle(app_uart_evt_t * p_event)
{
    if (p_event->evt_type == APP_UART_COMMUNICATION_ERROR)
    {
        APP_ERROR_HANDLER(p_event->data.error_communication);
    }
    else if (p_event->evt_type == APP_UART_FIFO_ERROR)
    {
        APP_ERROR_HANDLER(p_event->data.error_code);
    }
}

/**
 * @brief UART initialization.
 */
void PMDEBUG_uart_init(void)
{
	uint32_t  err_code;
	const app_uart_comm_params_t comm_params =
	{
		PIN_RxD,
    PIN_TxD,
    0,
    0,
    APP_UART_FLOW_CONTROL_DISABLED,
    false,
    UART_BAUDRATE_BAUDRATE_Baud921600
	};

  APP_UART_FIFO_INIT(&comm_params,
                       UART_RX_BUF_SIZE,
                       UART_TX_BUF_SIZE,
                       uart_error_handle,
                       APP_IRQ_PRIORITY_LOWEST,
                       err_code);

  APP_ERROR_CHECK(err_code);
	
	VT100_erasescreen();
}
