#include "m_ApplicationInterface.h"
#include "m_SensorProcessing.h"
#include "HTPA32x32.h"
#include "PrefiM_bsp.h"
#include "nrf_delay.h"
#include "MMA8652FC.h"
#include "BLE_writehandlers.h"
#include "ble_sgis.h"
#include "globals.h"
#include "nrf_log.h"
#include "m_ApplicationTimers.h"

void startTestOfPrefiM_BLE(uint8_t typeOfTest)
{
	char tempResult = TRUE;
	
	switch (typeOfTest)
	 {
		 case runmodeSGISTestInternalHardware:							//Check orientation of the device (Accelerometer
			NRF_LOG_INFO("Start internal hardware test\r\n");
			ble_sgis_result_update(m_conn_handle, p_sgis_main, 0x01);
	
			
			break;
		 
		 
		case runmodeSGISTestMount:										//Check orientation of the device (Accelerometer
			NRF_LOG_INFO("Start mount verification test\r\n");
			PMAT_start_timers();
			runtime_sgisTest = 0;										//Reset counter/timer 
			timer_sgisTest_running = TRUE;								//Start timer
			PMAIF_LED_Set(YELLOW,SOLID);
			beep();		
			//beep();	
			nrf_delay_ms(100);
				
			
			while(MMA8652_InHorizontalPosition()==false)
			{
					if(runtime_sgisTest>TIMER_SGIS_TEST_MOUNT_DELAY_TIMEOUT)
					{
						runtime_sgisTest = 0;														//Reset counter/timer 
						timer_sgisTest_running = FALSE;	
						PMAIF_LED_Set(RED,SOLID);
						nrf_delay_ms(50);
						PMAIF_LED_Set(ALL_OFF,SOLID);
						nrf_delay_ms(50);
						PMAIF_LED_Set(RED,SOLID);
						nrf_delay_ms(50);
						PMAIF_LED_Set(ALL_OFF,SOLID);
						nrf_delay_ms(50);
						tempResult = FALSE;	
						ble_sgis_result_update(m_conn_handle, p_sgis_main, 0x12);						
						break;
					}
			}
																				
			if(tempResult == TRUE)
				ble_sgis_result_update(m_conn_handle, p_sgis_main, 0x02);
			else
				ble_sgis_result_update(m_conn_handle, p_sgis_main, 0x12);
			
			break;
			
			
		case runmodeSGISTestUserInterface:										//Userinterface test
			NRF_LOG_INFO("Start user interface test\r\n");
			//PMBSP_set_leds(0xFF,0xFF,0x00,0xFF);
			PMAIF_LED_Set(WHITE,SOLID);
			nrf_delay_ms(1000);
			beep();		
			//beep();		
			//beep();		
			
			//Wait until magent places
			//while(PMBSP_read_Magnet()==false);
			PMAIF_LED_Set(GREEN,SOLID);
			PMAIF_DisableStove();	
			nrf_delay_ms(500);
			PMAIF_LED_Set(BLUE,SOLID);
			PMAIF_EnableStove();	
			nrf_delay_ms(500);
			PMAIF_LED_Set(YELLOW,SOLID);
			PMAIF_DisableStove();	
			nrf_delay_ms(500);
			PMAIF_SUMMER_Set(1);
			nrf_delay_ms(100);			

			//while(PMBSP_read_Magnet()==true);		//wiat for magnet to be removed
			PMAIF_LED_Set(GREEN,SOLID);
			nrf_delay_ms(500);
			
			ble_sgis_result_update(m_conn_handle, p_sgis_main, 0x03);
			
			break;
			
		case runmodeSGISTestSensor:										//Heatsensor test
			NRF_LOG_INFO("Start heat source recognition test\r\n");
			tempResult = TRUE;
			PMAT_start_timers();
			runtime_sgisTest = 0;										//Reset counter/timer 
			timer_sgisTest_running = TRUE;		
			PMAIF_LED_Set(MAGENTA,SOLID);
			nrf_delay_ms(1000);		
			//beep();	
			//beep();		
			//beep();		
			//beep();			
			HTPA32x32_readCompleteSensor();
			while(checkForTestHeatingZones()==false)
			{
				HTPA32x32_readCompleteSensor();
				
				if(runtime_sgisTest>TIMER_SGIS_TEST_SENSOR_DELAY_TIMEOUT)
				{
					runtime_sgisTest = 0;														//Reset counter/timer 
					timer_sgisTest_running = FALSE;												//Stop counter/timer
					ble_sgis_result_update(m_conn_handle, p_sgis_main, 0x14);
					tempResult = FALSE;
					break;
				}
			}
			if(tempResult == TRUE)
			{
				ble_sgis_result_update(m_conn_handle, p_sgis_main, 0x04);
				PMAIF_LED_Set(GREEN,SOLID);
				nrf_delay_ms(1000);
			}
			else
			{
				PMAIF_LED_Set(RED,SOLID);
				nrf_delay_ms(1000);
				ble_sgis_result_update(m_conn_handle, p_sgis_main, 0x14);
			}
			
			break;		
			
	 } //end switch	typeOfTest

			
			



	
}
