#include "globals.h"
#include "ble_sghs.h"
#include "PrefiM_bsp.h"

//----------------------------------------------------------------------------

// Det har gjorts saker som frstr belastningsidentifieringens mjligheter att gra ett bra jobb,
// t.ex har ett vred glmts p och en timer har lst ut => Kontaktorn har pulsat fr att bestlla om belastning
// fortfarande finns kvar. Detta gr att man inte kan lita p belastningstimrarna lngre.
// I detta fall r det lmpligt att anvnda denna funktion fr att nollstlla dessa och gra en ny belastningsidentifiering.

uint8_t DIPResult;

void invalidate_loadsense(void)
{
	load_hist_time_on = 0;
	load_hist_time_off = 0;
	load_on_valid = FALSE;
	load_off_valid = FALSE;

	load_type = LOAD_UNIDENT;
	loadstate = LS_NOLOAD;				// Tills vidare.
}

//----------------------------------------------------------------------------

void LoadStateMachine(void)
{

	if(mainstate == FIRE)				// Om vi hamnat i, eller r kvar i, FIRE stoppa och resetta all lastidentifiering!
	{
		loadstate = LS_FIRE;
	}

	switch(loadstate)
	{

// *********************************************************************************************************

		case LS_STARTUP:

			loadstate = LS_NOLOAD;
			BELASTNING_STATUS = LOAD_NONE;		// Signalera till MainStateMachine
			load_type = LOAD_UNIDENT;

		break;

// *********************************************************************************************************
// Vntetillstnd, hr vntar vi p att nn belastning skall sls till

		case LS_NOLOAD:

			// Vi har ingen belastning => Lasten nnu oidentifierad
	
//			load_type = LOAD_UNIDENT;
			BELASTNING_STATUS = LOAD_NONE;		// Signalera till MainStateMachine

			timer_stove_running = FALSE;
			runtime_stove = 0;

			// Frst: Kontrollera om vi har belastning till + att vi hller p och rknar "TILL"-tid i interruptet.
	
			if(load_is_on == TRUE)
			{
				load_hist_time_on = 0;			// Vi skall inte spara p tilltid d det r frsta gngen vi har belastning
				load_hist_time_off = 0;			// Vi skall inte spara p frntid d det r frsta gngen vi har belastning
				load_off_valid = FALSE;

				loadstate = LS_FIRSTON;
			}

		break;
// *********************************************************************************************************
// Ngon typ av belastning har precis slagits till.

  // Vi vet nnu inte vilken typ av last vi har, eller om den kommer att pulsera.
  // Vi antar att vi har en jrnspis, vilket r vr bsta gissning vi kan gra fr tillfllet
  // Skulle det ske ett frnslag = det visar sig att vi kanske har en pulserande last ndras identifieringen.

		case LS_FIRSTON:

//			load_type = LOAD_STOVE;				// vanlig spisplatta

			BELASTNING_STATUS = LOAD_ON;		// Signalera till MainStateMachine att vi har belastning

			timer_stove_running = TRUE;			//  Starta timern.

			// Har lasten slagits av?
	
			if(load_is_on == FALSE)
				loadstate = LS_FIRSTOFF;

			// Annars, vnta kvar i detta tillstnd!
			//Read dipswitch everytime the stove is on.
			
			//If wireless, update DIPSWITCH
			//#ifdef WIRELESS
			//DIPResult = PMBSP_read_DIP();	
			//ble_sghs_on_dip_change(m_conn_handle,&m_sghs, DIPResult);
			//#endif

		break;
// *********************************************************************************************************
// Belastningen har nu slagits av

		case LS_FIRSTOFF:

			if(load_on_valid == TRUE)		// Vi har en korrekt tidsmtning att anvnda
			{

// Fr att klara alla spisas kr vi numera 60 sekunders vntan, alltid!

				MAXRUNTIME = 600;					// vnta 60 sek p ny puls


/*
													// Belastningen var p mindre n 10 sek...
				MAXRUNTIME = 100;					// vnta 10 sek p ny puls

				if (load_hist_time_on >= 10)		// Belastningen var p mer n 10 sek => vnta 30 sek p ev ny belastning
				{
					MAXRUNTIME = 300;
				}

				if (load_hist_time_on >= 60)		// Belastningen var p mer n 60 sek => vnta 90 sek p ev ny belastning
				{
					MAXRUNTIME = 900;
				}
*/
			}
			else								// Konstigt nog har vi ingen OK tidsmtning, vilket vi borde ha.
				MAXRUNTIME = 900; // T_GENERAL_OFF_MAX;				// Lt oss vnta T_GENERAL_OFF_MAX (default 90) sekunder p att nsta frbrukningspuls kommer
																	// Vi har ju ingen aning om ifall det kommer fler frbrukningspulser

			loadstate = LS_WAITFIRSTLOAD;


		break;

// *********************************************************************************************************
// Belastningen har slagits ifrn frsta gngen. Vi kan inte sl av bevakningen direkt ifall det skulle komma fler pulser.
// Tiden vi skall vnta beror p vilken typ av last vi tror vi har = MAXRUNTIME, vilken satts till rtt vrde i tidigare tillstnd

		case LS_WAITFIRSTLOAD:

			BELASTNING_STATUS = LOAD_WAIT;		// Signalera till MainStateMachine att vi numera r i "vntelge"

			if (load_sense_timer > MAXRUNTIME)					// Vi har vntat tillrckligt lnge, och belastningen
			{													// har inte terkommit.
					loadstate = LS_NOLOAD;
			}

			// Kontrollera om vi har belastning till + att vi hller p och rknar "TILL"-tid i interruptet.
			
			if(load_is_on == TRUE)					// Vi har belastning till igen = Pulserande last
			{
				loadstate = LS_LOADON;
			}

		break;

// *********************************************************************************************************
// Belastningen har slagits till en andra gng. Det borde finnas OK till & frnslagstider att dra slutsatser frn!

		case LS_LOADON:

			BELASTNING_STATUS = LOAD_ON;		// Signalera till MainStateMachine att vi har belastning

			// Frst, se till att vi har "rtt" vntetid ifall belastningen skulle sls av
/*
			if((load_on_valid == TRUE) && (load_off_valid == TRUE)) // Vi har bde till och frnslag p belastningen = pulserande last
			{
						// Vi har OK tider, anvnd frnslagstiden plus 5 sekunder som vntetid fr att inte behva vnta fr lnge

				MAXRUNTIME = load_hist_time_off + 50;
			}
			else
						// Av nn konstig anledning r inte tidsdatat OK, vilket det borde vara.
						// Lt oss vnta i 60 sekunder tills vi anser att spisen r avstngd.
			{
				MAXRUNTIME = 600;
			}
*/

// Kr alltid 60 sekunder!
			MAXRUNTIME = 600;

			// Sen, se till att bevaka ifall lasten skulle sls av. 

			if(load_is_on == FALSE)
				loadstate = LS_LOADOFF;

			// Skulle lasten vara p "fr lnge" kommer MainStateMachine i tillmpliga fall bryta strmmen till spisen
			// och i samband med detta anvnds invalidateloadsense() fr att terstlla LoadStateMachine. => vi lmnar inte detta
			// tillstnd p annat vis n dessa tv.
	
		break;

// *********************************************************************************************************

		case LS_LOADOFF:


			BELASTNING_STATUS = LOAD_WAIT;		// Signalera till MainStateMachine att vi numera r i "vntelge"

			if (load_sense_timer > MAXRUNTIME)					// Vi har vntat tillrckligt lnge, och belastningen
			{													// har inte terkommit.
					loadstate = LS_NOLOAD;
			}

			if(load_is_on == TRUE)					// Vi har belastning till igen inom vntetiden = Pulserande last
			{
				loadstate = LS_LOADON;
			}

		break;

// *********************************************************************************************************
// En brand har detekterats, och MainStateMachine har intrtt i tillstndet "FIRE" -> Kontaktorn har slagit ifrn!
// Vi behver sluta dra slutsatser i LoadStateMachine och istllet terstlla den

		case LS_FIRE:
										// Indikera att vi passerad FIRE i loadstatemachine.
		loadstate = LS_NOLOAD;			// LoadStateMachine skall starta om!

		break;

	}
	
}
