#include "PrefiM_bsp.h"
#include "nrf_delay.h"
#include "nrf_gpio.h"
#include "m_ApplicationInterface.h"
#include "m_ApplicationTimers.h"
#include "globals.h"
#include "m_ProductionTest.h"
#include "m_InstallationsTestMagnet.h"
#include "BLE_middleware.h"
#include "m_SenseStateMachine.h"
#include "HTPA32x32.h"
#include "m_SensorProcessing.h"
#include "indications.h"
#include "m_LoadStateMachine.h"
#include "nrf_uart.h"
#include "m_PowerControl.h"

// Tillstnd i MainStateMachine
/*
#define STARTUP 1
#define STOVE_OFF 2
#define STOVE_ON 3
#define TEMPERATURE_WARNING_LEVEL_1 4
#define REST 5
#define CHECK_MAGNET 6
#define PRE_STOVE_OFF 7
#define FIRE 8
#define REST_CHECKMEASURE 9
#define REST_STARTMEASURE 10
#define REST_DELAY 11
#define PRE_REST 12
#define DOUBLECHECK_OFF 13
#define SHUTDOWN_TIME 14
#define SHUTDOWN_TEMP 15
#define SHUTDOWN_MAGNET 16
#define TEMPERATURE_WARNING_LEVEL_2 17
#define SHUTDOWN_AMBIENT_TEMP 18
*/
#define magIDLE 1
#define magMagnetPlaced 2
#define magMagnetRemoved 3
#define magInstallationTest 4



//static unsigned char mainstate = STARTUP;				// Main State Machine
static unsigned char magnetBLEstate = magIDLE;	// State machine to check user's intention for device to advertize or installation test
static unsigned char earlierState = STARTUP;

/*void sleep_management(void)
{
	ret_code_t err_code;
	PMAIF_LED_Set(ALL_OFF,SOLID);	
	PMAIF_LED_Set(ALL_OFF,SOLID);	
	HTPA32x32_stopSensor();	
	PMAT_stop_timers();	//stop timers so they dont trigger any events
	
		uint32_t fpscr_reg = __get_FPSCR();	
		__set_FPSCR(fpscr_reg &~FPU_EXCEPTION_MASK);								//clear FPU registers
	NVIC_ClearPendingIRQ(FPU_IRQn);	//	irqresult = NVIC_GetActive(SPIM0_SPIS0_TWIM0_TWIS0_SPI0_TWI0_IRQn);
	//PMAI_twi_uninit();	nrf_uart_disable(NRF_UART0);
//	nrf_twi_disable(NRF_TWI0);																							//DESSA MSTE VARA MED MEN JAG HAR PROBLEM MED ATT DRA IGNG DEM IGEN
//	nrf_twi_disable(NRF_TWI1);
//clear pending FPU interrupts	
//irqresult = NVIC_GetPendingIRQ(SPIM0_SPIS0_TWIM0_TWIS0_SPI0_TWI0_IRQn);
//irqresult = NVIC_GetPendingIRQ(SPIM1_SPIS1_TWIM1_TWIS1_SPI1_TWI1_IRQn);
	nrf_delay_ms(200);
		__WFE();
	//__SEV();
	__WFE();
	
	err_code = sd_app_evt_wait();
		PMAIF_LED_Set(ALL_OFF,SOLID);	
	PMAIF_LED_Set(ALL_OFF,SOLID);	
	PMAIF_LED_Set(ALL_OFF,SOLID);
		PMAIF_LED_Set(ALL_OFF,SOLID);	
	PMAIF_LED_Set(ALL_OFF,SOLID);	
	PMAIF_LED_Set(ALL_OFF,SOLID);
	APP_ERROR_CHECK(err_code);
	
/*	HTPA32x32_stopSensor();
	PMAT_stop_timers();	//stop timers so they dont trigger any events

	NVIC_DisableIRQ(SPIM0_SPIS0_TWIM0_TWIS0_SPI0_TWI0_IRQn);
	NVIC_DisableIRQ(SPIM1_SPIS1_TWIM1_TWIS1_SPI1_TWI1_IRQn);
	NVIC_ClearPendingIRQ(SPIM0_SPIS0_TWIM0_TWIS0_SPI0_TWI0_IRQn);
	NVIC_ClearPendingIRQ(SPIM1_SPIS1_TWIM1_TWIS1_SPI1_TWI1_IRQn);	

	
	NVIC_DisableIRQ(UARTE0_UART0_IRQn);
	NVIC_ClearPendingIRQ(UARTE0_UART0_IRQn);
			__SEV();
		__SEV();
		__SEV();
		__SEV();
//	nrf_uart_disable(NRF_UART0);
//	nrf_twi_disable(NRF_TWI0);
//	nrf_twi_disable(NRF_TWI1);
	
		__SEV();

	nrf_gpio_pin_clear(PIN_SPEAKER);
	
  nrf_gpio_pin_clear(PIN_SCL);
  nrf_gpio_pin_clear(PIN_SDA);	
	

	
	//put all i/o:s in right mode for minimizing powerconsumtion
	nrf_gpio_pin_clear(PIN_AudioSHDN);			//Turn off speaker

	uint32_t fpscr_reg = __get_FPSCR();
	__set_FPSCR(fpscr_reg &~FPU_EXCEPTION_MASK);								//clear FPU registers
	NVIC_ClearPendingIRQ(FPU_IRQn);															//clear pending FPU interrupts
	nrf_delay_ms(200);
	__WFE();
	__SEV();
	__WFE();
	
	err_code = sd_app_evt_wait();
	PMAIF_LED_Set(ALL_OFF,SOLID);	
	PMAIF_LED_Set(ALL_OFF,SOLID);	
	PMAIF_LED_Set(ALL_OFF,SOLID);	
	
		while(1)
		{
			PMAIF_LED_Set(ALL_OFF,SOLID);	
		}
	//nrf_twi_enable(NRF_TWI0);
	//nrf_twi_enable(NRF_TWI1);
	//nrf_uart_enable(NRF_UART0);
	//PMAT_start_timers();	
}*/
uint8_t MSM_GetState(void)
{
	return mainstate;
}

void nextStateFunction(void)
{
	earlierState = mainstate;
	
	switch(resultOfTemperatureAnalysis)
	{
		case TF_CUT_POWER:
			if(earlierState != SHUTDOWN_TEMP)
			{
				numberOfOverheatBreaks++;
				whenToMakeSoundIndication = 255;								//varialbe to handle when to make sound in different states, like SHUTDOWN_TEMP
			}
			mainstate = SHUTDOWN_TEMP;
		break;
		
		case TF_SECOND_LARM_LEVEL:
			mainstate = TEMPERATURE_WARNING_LEVEL_2;
		break;
		
		case TF_FIRST_LARM_LEVEL:
			mainstate = TEMPERATURE_WARNING_LEVEL_1;
		break;
		
		//case TF_OVER_BOILING:
		//	mainstate = STOVE_ON;
		
		//Hr skall det in en IF-sats som tittar p om vi har valt funktionen "Endast kokning tillten."
		
		//break;
		
		#ifdef POWER_SENSE
		case TF_STOVE_ON:
			if(BELASTNING_STATUS == LOAD_ON)
				mainstate = STOVE_ON;
			else if(BELASTNING_STATUS == LOAD_NONE)
				mainstate = STOVE_OFF;
		break;
		
		case TF_STOVE_OFF:
			if(BELASTNING_STATUS == LOAD_ON)
				mainstate = STOVE_ON;
			else if(BELASTNING_STATUS == LOAD_NONE)
				mainstate = STOVE_OFF;
		break;
		#else
		case TF_STOVE_ON:
			mainstate = STOVE_ON;
		break;
		
		case TF_STOVE_OFF:
			mainstate = STOVE_OFF;
		#endif
	}

		switch(SENSESTATE_OUTPUT)
		{
			case TEMP_LOW_FAST_RISING:
				mainstate = ALARM_DELAY;
				break;
			
			case TEMP_HIGH_FAST_RISING:
				mainstate = ALARM_DELAY;
				break;
			
			/*case MOVEMENT_DETECTED:
				mainstate = REST_DELAY;
				break;*/
		}
	
	
}


void MSM_MainStateMachine(void)
{
	//uint8_t MAGNETSTATUS;
	
	static uint32_t removetime_magnetkey = 0;
	//static uint8_t runmode = 0;
	//uint8_t DIPstatus;
	//uint8_t ambientTemperatureLimit;
	MAGNETSTATUS = PMBSP_read_Magnet();
	//nrf_gpio_pin_clear(PIN_VCC_HALL);

	
	
	
if (runmode == runmodeNORMAL)
{
	switch (mainstate)
  {
// *********************************************************************************************************
		case STARTUP:
			earlierState = mainstate;
	
			indicationsStartup();
			
			//9/4HTPA32x32_readCompleteSensor();
			//9/4saveTemperatureImage_1s();
			#ifdef POWER_SENSE
				invalidate_loadsense();							// Ingen belastningsmtning n.
			#endif
		
			#ifdef BATTERY_DRIVEN								
				
				if(BLE_connected_flag == true)			//If we are connected to the breaker unit BLE, than go to sleep and wait for BLE event.
					mainstate = STOVE_OFF;
				else
					mainstate = LINK_FAILED;
			#else
					mainstate = STOVE_OFF;
			#endif	
		
		
		
			//mainstate = STOVE_OFF;

			if(PMBSP_read_Magnet())										//If magnet is placed at startup, start the installationtest
			{
//				while(MAGNETSTATUS)
//						PMAIF_LED_Set(YELLOW,SOLID);
				while(PMBSP_read_Magnet())
				{
					PMAIF_LED_Set(YELLOW,SOLID);
				}
				PMAIF_LED_Set(ALL_OFF,SOLID);
				startInstallationTestMagnet();	
				
			}
				
//			timer_startup_running = TRUE;

//			if( runtime_startup < TIMER_STARTUP_TIMEOUT ) // Vi r i uppstartsfrdrjningen
//			{
//				// Kolla om TP3 (P0.29) dragits lg -> Vi skall till kalibreringsrutinen!

			if(PMBSP_read_Prodtest() == TRUE)
			{
				Start_ProdTest();						// I normalfallet returnerar vi aldrig frn detta anrop!
			}
				
//			}
//			else										// Uppstartsfrdrjningen r slut
//			{
//				timer_startup_running = FALSE;
//				runtime_startup = 0; // Se till att timern r nollstlld efter den anvnts
//	
//    	        mainstate = STOVE_OFF;                 //  prepare to go to next state
//		}

			
			
			
			
        break;


// *********************************************************************************************************
		case LINK_FAILED:
				if(BLE_connected_flag == true)			//If we are connected to the breaker unit BLE, than go to sleep and wait for BLE event.
				{
					mainstate = STOVE_OFF;
					/*PMAIF_EnableStove();
					nrf_delay_ms(20);
					PMAIF_DisableStove();
					nrf_delay_ms(20);
					PMAIF_EnableStove();
					nrf_delay_ms(20);
					PMAIF_DisableStove();
					nrf_delay_ms(20);
					PMAIF_EnableStove();
					nrf_delay_ms(20);
					PMAIF_DisableStove();
					nrf_delay_ms(20);
					PMAIF_EnableStove();
					nrf_delay_ms(20);
					
					
					while(1);
					*/
					
				}
				else
					mainstate = LINK_FAILED;					//Here we should verify that we are in advertising mode.
		
							
					PMAIF_LED_Set(BLUE,SOLID);	
					nrf_delay_ms(20);
					PMAIF_LED_Set(ALL_OFF,SOLID);
					nrf_delay_ms(20);
					
				
			break;
// *********************************************************************************************************		
		case STOVE_OFF:
				if(earlierState != STOVE_OFF)				//Send stoveguard status the first pass in this state
				{
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );
					whenToFlash = 255; 			//
					
				}
			
			#ifdef DEBUG_MODE	
			PMAIF_LED_Set(YELLOW,SOLID);	
			nrf_delay_ms(500);
			PMAIF_LED_Set(ALL_OFF,SOLID);
			nrf_delay_ms(100);
			#endif
				
			PMAIF_EnableStove(); // och sl p kontaktorn innnan
			nrf_delay_ms(500);
				
			#ifndef POWER_SENSE
			//Spis on, timer for time turned on.
			timer_stove_running = false;
			runtime_stove = 0;						//reset counter / time
			#endif
				
			earlierState = mainstate;
			indicationsStoveOff();
	
			whenToMakeSoundIndication = 255;			//If we use sound indication, start that state with making a beep.
	

			/*PMAIF_LED_Set(GREEN,SOLID);	
			nrf_delay_ms(1000);
			PMAIF_LED_Set(ALL_OFF,SOLID);					
			*/
			nextStateFunction();
			
			#ifdef BATTERY_DRIVEN									//Maybe we should have RADIO_BASED instead.
				
					//Put CPU and everything in sleep and wake up on BLE event.
				if(BLE_connected_flag == true)			//If we are connected to the breaker unit BLE, than go to sleep and wait for BLE event.
				{
					#ifdef POWER_SENSE
					if(LOAD_SENSE_PIN==0)
					{
						//PMAIF_EnableStove(); // Be sure that we enable stove before we go to sleep
						PMPC_sleepModeNormal();
					}
					//else
						//PMAIF_DisableStove();
						//sleep_management();
					#endif	
				}
				else
				{
					PMAIF_DisableStove();
					mainstate = LINK_FAILED;
					
				}
			#endif				
			
			//PMPC_sleepModeNormal();
			
			// Startkriterie nr vi inte har belastningsindikering?
			//1.51  nextStateFunction();
			
			//PMAIF_EnableStove(); // och sl p kontaktorn innnan
		
// DIP r instlld p att gra spisbrytaren magnetkontrollerad?			

			if(DIP_MagnetControlled == TRUE)					// Spisen kontrolleras med magneten
			{
				if(MAGNETSTATUS)							// Magneten r p plats, OK att starta om inte magnetnyckeltiden gtt ut
				{

						if(runtime_magnetkey < TIMER_MAGNETKEY_TIMEOUT)	// och tiden fr magnetnyckeln har inte gtt ut = tillt fortsatt anvndning
						{
							PMAIF_EnableStove();									// Dra kontaktor = gr det mjligt att anvnda spisen
							//indicationsStoveOff();	
				      if(BELASTNING_STATUS == LOAD_ON)           	// Har Spis eller ugn slagits p?
							{                       
				         mainstate = CHECK_MAGNET;
				      }

						}
						else											// Vi har en kvarglmd magnetnyckel
						{
								//PMAIF_LED_Set(RED,SOLID);				// Indikera att spisen inte kan anvndas
								#ifdef BATTERY_DRIVEN
									if(whenToFlash > flashIntervalStoveOn)
									{
										PMAIF_LED_Set(RED,SOLID);
										nrf_delay_ms(100);
										PMAIF_LED_Set(ALL_OFF,SOLID);
										
										whenToFlash = 0;
										
									}
									else
										whenToFlash++;
								#else
									PMAIF_LED_Set(RED,SOLID);
								#endif
								PMAIF_DisableStove();					// Stng av mjligheten att starta spisen
						}

				}
				else										// Magneten r borttagen
				{
					//PMAIF_LED_Set(RED,SOLID);				// Indikera att spisen inte kan anvndas
					#ifdef BATTERY_DRIVEN
						if(whenToFlash > flashIntervalStoveOn)
						{
							PMAIF_LED_Set(RED,SOLID);
							nrf_delay_ms(100);
							PMAIF_LED_Set(ALL_OFF,SOLID);
							
							whenToFlash = 0;
							
						}
						else
							whenToFlash++;
					#else
						PMAIF_LED_Set(RED,SOLID);
					#endif
					PMAIF_DisableStove();					// Stng av mjligheten att starta spisen
				}
			}			
			else												// Spisen r inte magnetkontrollerad => OK att starta den
			{
							//indicationsStoveOff();	
							//PMAIF_EnableStove(); // och sl p kontaktorn innnan
			//}
//			{

				if(runtime_magnetkey < TIMER_MAGNETKEY_TIMEOUT)	// och tiden fr magnetnyckeln har inte gtt ut = lt strmmen vara p s att spisen kan startas
				{
					PMAIF_EnableStove();									// Dra kontaktor = gr det mjligt att anvnda spisen
	
		      if(BELASTNING_STATUS == LOAD_ON)           	// Har Spis eller ugn slagits p?
					{                       
		         mainstate = CHECK_MAGNET;
		      }
	
				}
				else											// Vi har en kvarglmd magnetnyckel, sl av strmmen
				{
						PMAIF_LED_Set(RED,SOLID);				// Indikera att spisen inte kan anvndas
					
						PMAIF_DisableStove();					// Stng av mjligheten att starta spisen
				}

			}



        break;

// *********************************************************************************************************
		case CHECK_MAGNET:
				if(earlierState != CHECK_MAGNET)				//Send stoveguard status the first pass in this state
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );
				earlierState = mainstate;
        if(runtime_magnetkey < TIMER_MAGNETKEY_TIMEOUT)          // Det finns ingen kvarglmd magnetnyckel
        {
						mainstate = STOVE_ON;					                // ... s vi kan g vidare
				}
				else
				{
					mainstate = STOVE_OFF;
				}
        break;

// *********************************************************************************************************
		case STOVE_ON:		
			if(earlierState != STOVE_ON)				//Send stoveguard status the first pass in this state
			{
					DIPstatus = PMBSP_read_DIP();	
					ble_sghs_on_dip_change(m_conn_handle,&m_sghs, DIPstatus);
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );
	
			
			}
			earlierState = mainstate;
			indicationsStoveOn();
			//PMAIF_SUMMER_Set(OFF);
			if(DIP_MagnetControlled == false)
				PMAIF_EnableStove(); // och sl p kontaktorn innnan
			

		
			//sleep_mode = SLEEP_MODE_NORMAL;
			
			#ifndef POWER_SENSE
			//Spis on, timer for time turned on.
			timer_stove_running = true;
			#endif
			
			if( (DIP_Timer > 0) && (runtime_stove > DIP_Timer) )			// Anvndningstid spis slut
			{																													// =>  stng av om inte magnetnyckeln sger annat
				whenToMakeSoundIndication = 255;													//varialbe to handle when to make sound in different states, like SHUTDOWN_TEMP
				mainstate = SHUTDOWN_TIME;
				numberOfTimerBreaks++;																	//rkna upp rknare som hller koll p antalet brytningar pga timer

				if(MAGNETSTATUS)									// Det sitter en magnetnyckel p plats
				{
					if(runtime_magnetkey < TIMER_MAGNETKEY_TIMEOUT)	// och tiden fr magnetnyckeln har inte gtt ut = tillt fortsatt anvndning
						mainstate = STOVE_ON;
				}
       }
		   else
				nextStateFunction();
	

			#ifdef POWER_SENSE
 			if(BELASTNING_STATUS == LOAD_NONE)          		// Detta borde inte kunna ske innan vi passerad LOAD_WAIT. Hantera  det nd fr skerhets skull!
			{
				mainstate = STOVE_OFF;		
				//PMAIF_DisableStove();					// Break current/stove

			}
			#endif
//			if(overheat())          // Overheat = Low Alarm
//    		{
//    			mainstate = WARNING;                //   prepare to go to next state
//    		}

			// Kolla om "brand" uppsttt
//			if(fire())
//			{
//				timer_warning_running = FALSE;
//		
//				mainstate = FIRE;
//			}

			if(DIP_MagnetControlled == TRUE)					// Spisen kontrolleras med magneten
			{

				if(runtime_magnetkey < TIMER_MAGNETKEY_TIMEOUT)	// och tiden fr magnetnyckeln har inte gtt ut = tillt fortsatt anvndning
				{
						// Gr ingenting till vidare...
				}
				else
				{
					mainstate = SHUTDOWN_MAGNET;
				}

				if(!MAGNETSTATUS)							// Magneten r borta! Stng omedelbart av!
				{
	    			mainstate = SHUTDOWN_MAGNET;
				}
			}			


        break;

// *********************************************************************************************************
// Hr hamnar vi om temperaturen r "fr hg", men inte s hg att det r "brand", frsta larmnivn

		case TEMPERATURE_WARNING_LEVEL_1:
				if(earlierState != TEMPERATURE_WARNING_LEVEL_1)				//Send stoveguard status the first pass in this state
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );

			earlierState = mainstate;
			indicationsTemperatureWarningLevel_1();
			PMAIF_EnableStove(); // och sl p kontaktorn innnan
		
			#ifndef POWER_SENSE
			//Spis on, timer for time turned on.
			timer_stove_running = true;
			#endif
		
			if( (DIP_Timer > 0) && (runtime_stove > DIP_Timer) )			// Anvndningstid spis slut
			{																// =>  stng av om inte magnetnyckeln sger annat
				mainstate = SHUTDOWN_TIME;
				numberOfTimerBreaks++;			//rkna upp rknare som hller koll p antalet brytningar pga timer

				if(MAGNETSTATUS)									// Det sitter en magnetnyckel p plats
				{
					if(runtime_magnetkey < TIMER_MAGNETKEY_TIMEOUT)	// och tiden fr magnetnyckeln har inte gtt ut = tillt fortsatt anvndning
						mainstate = TEMPERATURE_WARNING_LEVEL_1;
				}
       }
			else
					nextStateFunction();
			
			
			if(DIP_MagnetControlled == TRUE)					// Spisen kontrolleras med magneten
			{

				if(runtime_magnetkey < TIMER_MAGNETKEY_TIMEOUT)	// och tiden fr magnetnyckeln har inte gtt ut = tillt fortsatt anvndning
				{
						// Gr ingenting till vidare...
				}
				else
				{
					mainstate = SHUTDOWN_MAGNET;
				}

				if(!MAGNETSTATUS)							// Magneten r borta! Stng omedelbart av!
				{
	    			mainstate = SHUTDOWN_MAGNET;
				}
			}			


        break;
// *********************************************************************************************************
// Hr hamnar vi om temperaturen r "fr hg" samtidigt som den nrmare sig brytnivn, men inte s hg att det r "brand", andra larmnivn		
		case TEMPERATURE_WARNING_LEVEL_2:
				if(earlierState != TEMPERATURE_WARNING_LEVEL_2)				//Send stoveguard status the first pass in this state
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );
				
				earlierState = mainstate;
				indicationsTemperatureWarningLevel_2();
				PMAIF_EnableStove(); // och sl p kontaktorn innnan
				
		
				if(DIP_Sound_warning == TRUE)		//Om "Warning sound" r ON, dra summern.
    				beep();

				#ifndef POWER_SENSE
				//Spis on, timer for time turned on.
				timer_stove_running = true;
				#endif
			
				if( (DIP_Timer > 0) && (runtime_stove > DIP_Timer) )			// Anvndningstid spis slut
				{																// =>  stng av om inte magnetnyckeln sger annat
					mainstate = SHUTDOWN_TIME;	
					numberOfTimerBreaks++;			//rkna upp rknare som hller koll p antalet brytningar pga timer
					if(MAGNETSTATUS)									// Det sitter en magnetnyckel p plats
					{
						if(runtime_magnetkey < TIMER_MAGNETKEY_TIMEOUT)	// och tiden fr magnetnyckeln har inte gtt ut = tillt fortsatt anvndning
							mainstate = TEMPERATURE_WARNING_LEVEL_2;
					}
				 }
				else
						nextStateFunction();

				if(DIP_MagnetControlled == TRUE)					// Spisen kontrolleras med magneten
				{

					if(runtime_magnetkey < TIMER_MAGNETKEY_TIMEOUT)	// och tiden fr magnetnyckeln har inte gtt ut = tillt fortsatt anvndning
					{
							// Gr ingenting till vidare...
					}
					else
					{
						mainstate = SHUTDOWN_MAGNET;
					}

					if(!MAGNETSTATUS)							// Magneten r borta! Stng omedelbart av!
					{
							mainstate = SHUTDOWN_MAGNET;
					}
				}			

		
        break;

// *********************************************************************************************************
// Hr hamnar vi vid en tvingande nedstngning d anvndaren har tagit bort magnetnyckeln vid magnetkontrollerad spis

		case SHUTDOWN_MAGNET:
			if(earlierState != SHUTDOWN_MAGNET)				//Send stoveguard status the first pass in this state
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );
			
			earlierState = mainstate;
			indicationsShutdownMagnet();
			//RED_LED_STATUS = LED_ON;
			//GREEN_LED_STATUS = LED_OFF;
			//SUMMER_STATUS = SUMMER_OFF;

			PMAIF_DisableStove(); //Cut power
		
			#ifdef POWER_SENSE
			invalidate_loadsense();			// Se till att vi brjar om frn brjan med loadsense
			#endif

			mainstate = STOVE_OFF;			// Hoppa (ovillkorligt) till StoveOff fr att kunna starta om spisen

        break;

// *********************************************************************************************************
// Hr hamnar vi vid en tvingande nedstngning = Anvndaren har inte reagerat p en indikerad verhettning genom att dra ner p vrmen

		case SHUTDOWN_TEMP:
				if(earlierState != SHUTDOWN_TEMP)				//Send stoveguard status the first pass in this state
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );
				earlierState = mainstate;
				indicationsShutdownTemperature();
				//PMAIF_SUMMER_Set(1);
				PMAIF_DisableStove(); //Cut power
		
				//if(resultOfTemperatureAnalysis == TF_STOVE_OFF)										//Hr kanske vi skulle stta en timer fr att se att vi inte kommer upp i temperatur relativt omgende (ngon har glmt spisen p).
				//	mainstate = STOVE_OFF;
			#ifdef POWER_SENSE
			invalidate_loadsense();			// Se till att vi brjar om frn brjan med loadsense
			PREREST_WaitTime = TIMER_PRE_TEMP_DELAY;			// Lt oss vnta 60 sekunder!	
			KONTAKTOR_WaitTime = 10;			// Starta med 10 sekunders intervall mellan kontaktortillslagen
			runtime_rest = 0;
			
			runtime_kontaktor = 0;
				
			mainstate = PRE_REST;
			#else			
				if((MOVEMENT_FLAG ==TRUE)&&(resultOfTemperatureAnalysis == TF_STOVE_OFF))				//Hr br man starta en timer som ger anvndaren lite tid att f ned temperaturen.
					mainstate = STOVE_OFF;
			#endif
	
				
//			RED_LED_STATUS = LED_ON;
//			GREEN_LED_STATUS = LED_OFF;
//			SUMMER_STA TUS = SUMMER_OFF;

//			release_contactor(100);		// Stng av spisen fr att inte frorsaka uppvrmning
//			invalidate_loadsense();

//			PREREST_WaitTime = TIMER_PRE_TEMP_DELAY;			// Lt oss vnta 60 sekunder!	
//			KONTAKTOR_WaitTime = 10;			// Starta med 10 sekunders intervall mellan kontaktortillslagen

//			runtime_rest = 0;
//			mainstate = PRE_REST;

        break;

// *********************************************************************************************************
// 

		case SHUTDOWN_TIME:
				if(earlierState != SHUTDOWN_TIME)				//Send stoveguard status the first pass in this state
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );
				earlierState = mainstate;
				indicationsShutdownTime();
				PMAIF_DisableStove(); //Cut power
				//Stay in this state until movement detected
		
			#ifdef POWER_SENSE
			invalidate_loadsense();			// Se till att vi brjar om frn brjan med loadsense
			PREREST_WaitTime = TIMER_PRE_TEMP_DELAY;			// Lt oss vnta 60 sekunder!	
			KONTAKTOR_WaitTime = 10;			// Starta med 10 sekunders intervall mellan kontaktortillslagen
			runtime_rest = 0;
			mainstate = PRE_REST;
			#else		
				if(MOVEMENT_FLAG ==TRUE)
					mainstate = STOVE_OFF;
				if(resultOfTemperatureAnalysis == TF_STOVE_OFF)										//Hr kanske vi skulle stta en timer fr att se att vi inte kommer upp i temperatur relativt omgende (ngon har glmt spisen p).
					mainstate = STOVE_OFF;
			#endif
			
				
//			GREEN_LED_STATUS = LED_OFF;
//			SUMMER_STATUS = SUMMER_OFF;

//			release_contactor(100);		// Stng av spisen fr att inte frorsaka uppvrmning
//			invalidate_loadsense();

//			PREREST_WaitTime = TIMER_PRE_TIME_DELAY;			// Lt oss vnta 60 sekunder!	
//			KONTAKTOR_WaitTime = 10;			// Starta med 10 sekunders intervall mellan kontaktortillslagen

//			runtime_rest = 0;
//			mainstate = PRE_REST;

		break;

// *********************************************************************************************************
// Ta en paus efter att ha slagit av strmmen, spisen kan behva svalna, termostater terstllas, elektronik tappa minnet etc.

		case PRE_REST:
				if(earlierState != PRE_REST)				//Send stoveguard status the first pass in this state
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );

				#ifdef DEBUG_MODE
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				#endif
				
			earlierState = mainstate;
			indicationsPREREST();
			/*RED_LED_STATUS = LED_ON;
			GREEN_LED_STATUS = LED_OFF;

		if ( DIP_use_Indicator == TRUE )	// Lt summern tuta till en kort stund (indikator fr synskadade)
		{
			SUMMER_STATUS = SUMMER_IND_REST;
		}
		else
		{
			SUMMER_STATUS = SUMMER_OFF;
		}*/
		
			//Override function implemented in RC 1_517
			if(hotestTemperature < TL_STOVE_ON)
				mainstate = STOVE_OFF;
		
			#ifdef POWER_SENSE
			timer_rest_running = TRUE;

			if (runtime_rest > PREREST_WaitTime)	
			{										

				timer_rest_running = FALSE;
				runtime_rest = 0;
				mainstate = REST;
			}
			#endif
		break;

// *********************************************************************************************************
// Vilolge

		case REST:
			if(earlierState != REST)				//Send stoveguard status the first pass in this state
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );

			earlierState = mainstate;
			indicationsPREREST();
				#ifdef DEBUG_MODE
			nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				#endif

			#ifdef POWER_SENSE
			timer_kontaktor_running = TRUE;						// Starta / terstarta timern som rknar hur lnge kontaktorn skall vila mellan tillslagen.

			if ( runtime_kontaktor < KONTAKTOR_WaitTime ) 		// Vi skall vnta i detta tillstnd eftersom det
			{													// inte r dax att kolla belastningen n
			
					// Stanna kvar i REST

			}
			else									// Kontaktortimern har lpt ut. Ligger belastningen fortfarande kvar?
			{
//													// Starta tidsstyrd belastningsmtning!
//													// Belastningsmtningen skall pg s kort som mjligt i fallet med
//													// vanliga jrnspisar fr att frhindra uppvrmning.
//													// I fallet med pulserande laster mste belastningsmtningen skerstlla
//													// att belastningen verkligen r avstngd och vi inte bara rkar mta
//													// d termostaten fr tillfllet rkar vara avstngd

				runtime_rest = 0;

//			// Beroende p typ av belastning kan vi behva en frdrjning innan vi mter belastning
//			// T.ex induktion: En frdrjning innan belastning mts efter att kontaktorn dragits fr
//			// att frhindra problem om hllen drar mycket strm i uppstartsskedet?

//			// Dock, i och med att vi inte vet vad vi har fr spis vill vi hlla tiden s kort som mjligt fr att frhindra uppvrmning

  			mainstate = REST_DELAY;

			}
			#endif

//			// Kolla om "brand" uppsttt
//			if(fire())
//			{
//				mainstate = FIRE;
//			}
        break;

// *********************************************************************************************************
		case REST_DELAY:
				if(earlierState != REST_DELAY)				//Send stoveguard status the first pass in this state
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );

				earlierState = mainstate;
				indicationsRESTDELAY();
				
				#ifdef DEBUG_MODE
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				#endif
				//PMAIF_LED_Set(GREEN,FAST_BLINK);
				//nrf_delay_ms(1000);
				//nextStateFunction();
				PMAIF_EnableStove();
//			CONTACTOR_OUT_PIN = 0;				// Dra kontaktor utan tidskontroll
				#ifdef POWER_SENSE
					timer_rest_running = TRUE;

					if (runtime_rest >= TIMER_RESTART_DELAY)		// Vi skall pbrja mtning frst efter att timern lpt ut fr att ge t.ex. en induktionshll
					{											// tid att starta upp innan mtning grs!
						timer_rest_running = FALSE;
						runtime_rest = 0;
						mainstate = REST_STARTMEASURE;
						//The 10Hz timer must be on when entering the REST_STARTMEASURE state
						PMAT_start_timers();
					}
				#else
									nextStateFunction();
				#endif

		break;
					
	// *********************************************************************************************************
		case ALARM_DELAY:
				if(earlierState != REST_DELAY)				//Send stoveguard status the first pass in this state
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );

				//nextStateFunction();
				earlierState = mainstate;
				indicationsALARMDELAY();
				//PMAIF_LED_Set(GREEN,FAST_BLINK);
				//nrf_delay_ms(1000);
				//nextStateFunction();
				PMAIF_EnableStove();
//			CONTACTOR_OUT_PIN = 0;				// Dra kontaktor utan tidskontroll
				nextStateFunction();
				

		break;

// *********************************************************************************************************
// Vi har tagit oss frbi eventuella frdrjningar fr uppstart av elektroniken i spisen, spisen har svalnat etc... Starta mtning fr att se om belastning r till!

		case REST_STARTMEASURE:
				if(earlierState != REST_STARTMEASURE)				//Send stoveguard status the first pass in this state
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );

			earlierState = mainstate;
				
				#ifdef DEBUG_MODE
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				#endif	
			
			PowerMeasureLoadOn = FALSE;			// Nollstll indikeringsflaggan fr pgende omedelbar belastningsmtning innan vi startar en ny mtning

				// PowerMeasurePeriod innehller vntetiden, men r ven startsignalen fr mtningen.

			PowerMeasurePeriod = 10;		// Maximal tid att vnta p belastning (1 sekund) + Initiera belastningsmtningen
			PowerMeasureStatus = TRUE;			// Indikera att vi hller p och mter belastning.
													// Denna stts ven i interruptet, men behvs sttas ven hr fr att inte generera ev osannolika race conditions

			mainstate = REST_CHECKMEASURE;
			


		break;

// *********************************************************************************************************
		case REST_CHECKMEASURE:
				if(earlierState != REST_CHECKMEASURE)				//Send stoveguard status the first pass in this state
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );

			earlierState = mainstate;
//			// Kolla frst om belastningsmtningen fortfarande pgr
				#ifdef DEBUG_MODE
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				PMAIF_LED_Set(CYAN,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				#endif	
			if(PowerMeasureStatus == TRUE)		// Belastningsmtningen i interruptet r inte klar n!
			{
				#ifdef DEBUG_MODE
				PMAIF_LED_Set(BLUE,SOLID);
				nrf_delay_ms(100);
				PMAIF_LED_Set(ALL_OFF,SOLID);
				nrf_delay_ms(500);
				#endif
				// Lt oss vnta p att den blir klar.

			}
			else	// Belastningsmtningen r avslutad.	// ... r den inte det kan tiden fr belastningsmtningen ha lpt ut?
			{

				invalidate_loadsense();

				if (PowerMeasureLoadOn == TRUE)			// Belastning detekterades under mtningen!
				{
									#ifdef DEBUG_MODE
									PMAIF_LED_Set(BLUE,SOLID);
									nrf_delay_ms(100);
									PMAIF_LED_Set(ALL_OFF,SOLID);
									nrf_delay_ms(500);
									PMAIF_LED_Set(BLUE,SOLID);
									nrf_delay_ms(100);
									PMAIF_LED_Set(ALL_OFF,SOLID);
									nrf_delay_ms(500);
									#endif
					timer_kontaktor_running = FALSE;	// Stoppa kontaktortimern
					runtime_kontaktor = 0;
					
					if (KONTAKTOR_WaitTime < TIMER_KONTAKTOR_MAXPAUSTIME)	// Vnta kande tidsintervall fr att spara p kontaktorn
						KONTAKTOR_WaitTime += 5;		// Annars stanna tiden p TIMER_KONTAKTOR_MAXPAUSTIME (3 minuter i skrivande stund)
	
					mainstate = REST;
				}
				else									// Ingen belastning detekterades under mtningen.
				{
							#ifdef DEBUG_MODE
									PMAIF_LED_Set(BLUE,SOLID);
									nrf_delay_ms(100);
									PMAIF_LED_Set(ALL_OFF,SOLID);
									nrf_delay_ms(500);
									PMAIF_LED_Set(BLUE,SOLID);
									nrf_delay_ms(100);
									PMAIF_LED_Set(ALL_OFF,SOLID);
									nrf_delay_ms(500);
									PMAIF_LED_Set(BLUE,SOLID);
									nrf_delay_ms(100);
									PMAIF_LED_Set(ALL_OFF,SOLID);
									nrf_delay_ms(500);
									#endif
					timer_kontaktor_running = FALSE;	// Stoppa kontaktortimern
					runtime_kontaktor = 0;


					runtime_rest = 0;
					timer_rest_running = TRUE;
					mainstate = DOUBLECHECK_OFF;			// Belastningen har inte terkommit under vntetiden -> Last troligen avstngd.
				}
			}

		break;

// *********************************************************************************************************
		case DOUBLECHECK_OFF:
				if(earlierState != DOUBLECHECK_OFF)				//Send stoveguard status the first pass in this state
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );

				earlierState = mainstate;
				if (BELASTNING_STATUS != LOAD_NONE)			// Belasningen r till igen, spisen r inte riktigt avstngd!
				{
					timer_rest_running = FALSE;
					runtime_rest = 0;

					PMAIF_DisableStove();  			//cut power
					//release_contactor(100);		// Stng av spisen fr att inte frorsaka uppvrmning
					invalidate_loadsense();

					KONTAKTOR_WaitTime = 10;			// Starta med 10 sekunders intervall mellan kontaktortillslagen

					mainstate = REST;
				}

				if (runtime_rest > 10)		// Vnta 10 sekunder med kontaktorn tillslagen. Under denna tid skall ingen last terkomma
				{
					timer_rest_running = FALSE;
					runtime_rest = 0;
					mainstate = PRE_STOVE_OFF;			// Belastningen har inte terkommit under vntetiden -> Last avstngd.
				}
		break;

// *********************************************************************************************************
		case PRE_STOVE_OFF:
				if(earlierState != PRE_STOVE_OFF)				//Send stoveguard status the first pass in this state
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );

				earlierState = mainstate;
				invalidate_loadsense();							// Ingen kvarvarande belastningsmtningsdata till nsta tillslag

				mainstate = STOVE_OFF;

   		break;

// *********************************************************************************************************
		case FIRE:
				if(earlierState != FIRE)				//Send stoveguard status the first pass in this state
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );

			earlierState = mainstate;
			indicationsFire();
//			RED_LED_STATUS = LED_FAST_BLINK;
//			GREEN_LED_STATUS = LED_OFF;
//			SUMMER_STATUS = SUMMER_FIRE;

//			// Stoppa alla pgende timers!

//			// timer_stove och timer_owen skts av LoadStateMachine.

//			timer_magnetkey_running = FALSE;
//			runtime_magnetkey = 0;

//			timer_warning_running = FALSE;
//			runtime_warning = 0;

//			timer_startup_running = FALSE;
//			runtime_startup = 0;

//			timer_kontaktor_running = FALSE;
//			runtime_kontaktor = 0;

//			release_contactor(100);
//			invalidate_loadsense();

//            if(!fire())          // Temperaturen har minskat
//            {                         
//               	KONTAKTOR_WaitTime = 1;			// Starta med 1 sekunds intervall mellan kontaktortillslagen
//				mainstate = SHUTDOWN_TEMP;      
//            }

//			// Hamnar vi hr r sensornivn fortfarande ver "brand"nivn. Stanna kvar i detta tillstnd tills temperaturen sjunkit.

        break;

// *********************************************************************************************************
		case SHUTDOWN_AMBIENT_TEMP:
				if(earlierState != SHUTDOWN_AMBIENT_TEMP)				//Send stoveguard status the first pass in this state
					ble_sghs_on_stoveguardstatus_change(m_conn_handle, &m_sghs, mainstate );
				earlierState = mainstate;

				
				indicationsShutdownAmbientTemp();
				PMAIF_DisableStove(); //Cut power
				//Stay in this state until movement detected
				if(MOVEMENT_FLAG ==TRUE)
					mainstate = STOVE_OFF;
			if(resultOfTemperatureAnalysis == TF_STOVE_OFF)										//Hr kanske vi skulle stta en timer fr att se att vi inte kommer upp i temperatur relativt omgende (ngon har glmt spisen p).
				mainstate = STOVE_OFF;
        break;
	} // State machine switch

// *********************************************************************************************************

} // runmode check

// Saker som skall gras varje varv i tillstndsmaskinen

	//Check that ambient temperature is lower than limit
	//ambientTemperatureLimit= AMBIENT_TEMPERATURE_MAX_LIMIT;
	if( TaSensor > AMBIENT_TEMPERATURE_MAX_LIMIT)
	{
		mainstate = SHUTDOWN_AMBIENT_TEMP;
		
	}
	// Kolla om magnetnyckeln r p plats + hantera dess timer	
	
	if(MAGNETSTATUS)
	{
		//if(timer_magnetkey_running == FALSE)
		//	PMAT_timers_init();		
		timer_magnetkey_running = TRUE;
		
		if (runtime_magnetkey > TIMER_MAGNETKEY_TIMEOUT)	// Se till att timern stannar om timeout r uppndd
			runtime_magnetkey = TIMER_MAGNETKEY_TIMEOUT;

		if ((runtime_magnetkey > 2) && (runtime_magnetkey < 5))	// Magnet was removed has been positioned for the expected time
		{
				//PMAIF_LED_Set(BLUE,SOLID);
				
		}/*
		else if ((removetime_magnetkey > 8) && (removetime_magnetkey < 12))	// Magnet was removed has been positioned for the expected time
		{
				PMAIF_LED_Set(YELLOW,SOLID);
		}*/
				
		removetime_magnetkey = runtime_magnetkey;

	}
	else
	{
		timer_magnetkey_running = FALSE;
		runtime_magnetkey = 0;
	}

		//	printf("removetime_magnetkey=%u\r",removetime_magnetkey);
	
	
	switch (magnetBLEstate)
  {
		case magIDLE:

//		printf("\r\n magIDLE \r\n");
	
			
			if(MAGNETSTATUS)
				magnetBLEstate = magMagnetPlaced;
			
		break;
		
		case magMagnetPlaced:

			if(!MAGNETSTATUS) // Magnet removed...
			{
				if ((removetime_magnetkey > 2) && (removetime_magnetkey < 5))	// Magnet was removed has been positioned for the expected time
				{
						//PMAIF_LED_Set(BLUE,SOLID);
						magnetBLEstate = magMagnetRemoved;
				}
				else if ((removetime_magnetkey > 8) && (removetime_magnetkey < 12))	// Magnet was removed has been positioned for the expected time
				{
						magnetBLEstate = magInstallationTest;
						PMAIF_LED_Set(YELLOW,SOLID);
				}
				else // We are outside specified time
				{
						magnetBLEstate = magIDLE;
				}
			}
				
		break;
			
		case magMagnetRemoved:	
				
			//printf("\r\n-- Advertizing started by magnet --\r\n");
			PMBLE_advertising_start(0);	// Start advertizing
			runmode = runmodeADVERTIZING;
			PMAIF_LED_Set(BLUE,FAST_BLINK);
			timer_advertising_running = true;
			magnetBLEstate = magIDLE;
			
		break;
		
		case magInstallationTest:	
				
			printf("\r\n-- Installation test started by magnet --\r\n");
			//PMBLE_advertising_start(0);	// Start advertizing
			
			startInstallationTestMagnet();
			runmode = runmodeNORMAL;
			magnetBLEstate = magIDLE;
		break;
	}
	
}

