#include "m_ApplicationInterface.h"
#include "globals.h"
#include "HTPA32x32.h"
#include "PrefiM_bsp.h"
#include "nrf_delay.h"
#include "nrf_gpio.h"
#include "m_ApplicationTimers.h"
#include "m_PowerControl.h"
// ****************************************  Sleep functions  ****************************************

///**@brief Function for putting the chip into sleep mode.
// *
// * @note This function will not return.
// */
//static void sleep_mode_enter(void)
//{
//    ret_code_t err_code;

//    err_code = bsp_indication_set(BSP_INDICATE_IDLE);
//    APP_ERROR_CHECK(err_code);

//    // Prepare wakeup buttons.
////    err_code = bsp_btn_ble_sleep_mode_prepare();
////    APP_ERROR_CHECK(err_code);

//    // Go to system-off mode (this function will not return; wakeup will cause a reset).
//    err_code = sd_power_system_off();
//    APP_ERROR_CHECK(err_code);
//}

// ****************************************  Power measurement  ****************************************

///**@brief Function for performing battery measurement and updating the Battery Level characteristic
// *        in Battery Service.
// */
//static void battery_level_update(void)
//{
//    ret_code_t err_code;
//    uint8_t  battery_level;

//    battery_level = (uint8_t)sensorsim_measure(&m_battery_sim_state, &m_battery_sim_cfg);

//    err_code = ble_bas_battery_level_update(&m_bas, battery_level);
//    if ((err_code != NRF_SUCCESS) &&
//        (err_code != NRF_ERROR_INVALID_STATE) &&
//        (err_code != NRF_ERROR_RESOURCES) &&
//        (err_code != BLE_ERROR_GATTS_SYS_ATTR_MISSING)
//       )
//    {
//        APP_ERROR_HANDLER(err_code);
//    }
//}


///**@brief Function for handling the Battery measurement timer timeout.
// *
// * @details This function will be called each time the battery level measurement timer expires.
// *
// * @param[in] p_context  Pointer used for passing some arbitrary information (context) from the
// *                       app_start_timer() call to the timeout handler.
// */
//static void battery_level_meas_timeout_handler(void * p_context)
//{
//    UNUSED_PARAMETER(p_context);
//    battery_level_update();
//}

///**@brief Function for handling the "deep-sleep" waiting for BLE event.
// *
// * @details This function will be called each time the powerconsumtion will be zero. All timers and so on is stopped, sensor is stopped and so on.
// *
// * @param[in] p_context  Pointer used for passing some arbitrary information (context) from the
// *                       app_start_timer() call to the timeout handler.
// */
void PMPC_sleepModeNormal(void)
{
	ret_code_t err_code;
	PMAIF_LED_Set(ALL_OFF,SOLID);	
	PMAIF_LED_Set(ALL_OFF,SOLID);	
	//HTPA32x32_stopSensor();	
	//PMAIF_StopI2C();								//Put SDA/SCL in right mode
	nrf_delay_ms(200);
	nrf_gpio_cfg_output(PIN_SDA);
	nrf_gpio_cfg_output(PIN_SCL);
	nrf_gpio_pin_set(PIN_SDA);
	nrf_gpio_pin_set(PIN_SCL);
	
	
	nrf_gpio_pin_clear(PIN_VCC_HALL);			//Shut down power to HALL sensors
	PMAT_stop_timers();	//stop timers so they dont trigger any events
	
		uint32_t fpscr_reg = __get_FPSCR();	
		__set_FPSCR(fpscr_reg &~FPU_EXCEPTION_MASK);								//clear FPU registers
	NVIC_ClearPendingIRQ(FPU_IRQn);	//	irqresult = NVIC_GetActive(SPIM0_SPIS0_TWIM0_TWIS0_SPI0_TWI0_IRQn);
	//PMAI_twi_uninit();	nrf_uart_disable(NRF_UART0);
//	nrf_twi_disable(NRF_TWI0);																							//DESSA MSTE VARA MED MEN JAG HAR PROBLEM MED ATT DRA IGNG DEM IGEN
//	nrf_twi_disable(NRF_TWI1);
//clear pending FPU interrupts	
//irqresult = NVIC_GetPendingIRQ(SPIM0_SPIS0_TWIM0_TWIS0_SPI0_TWI0_IRQn);
//irqresult = NVIC_GetPendingIRQ(SPIM1_SPIS1_TWIM1_TWIS1_SPI1_TWI1_IRQn);
	//nrf_delay_ms(200);
	__WFE();
	//__SEV();
	__WFE();
	err_code = sd_app_evt_wait();
	err_code = sd_app_evt_wait();
}
///**@brief Function for handling the "deep-sleep" waiting for BLE event.
// *
// * @details This function will be called each time the powerconsumtion will be zero. All timers and so on is stopped, sensor is stopped and so on.
// *
// * @param[in] p_context  Pointer used for passing some arbitrary information (context) from the
// *                       app_start_timer() call to the timeout handler.
// */
void PMPC_sleepMode_30s(void)
{
		ret_code_t err_code;
	PMAIF_LED_Set(ALL_OFF,SOLID);	
	PMAIF_LED_Set(ALL_OFF,SOLID);	
	//HTPA32x32_stopSensor();	
	//PMAIF_StopI2C();								//Put SDA/SCL in right mode
	nrf_delay_ms(200);
	nrf_gpio_cfg_output(PIN_SDA);
	nrf_gpio_cfg_output(PIN_SCL);
	nrf_gpio_pin_set(PIN_SDA);
	nrf_gpio_pin_set(PIN_SCL);					//Put SDA/SCL in right mode
	
	nrf_gpio_pin_set(PIN_VCC_HALL);			//Shut down power to HALL sensors
	PMAT_start_30s_timers();
	PMAT_stop_01s_1s_15s_timers();	//stop 0.1s, 1s and 15s timers so they dont trigger any events
	
		uint32_t fpscr_reg = __get_FPSCR();	
		__set_FPSCR(fpscr_reg &~FPU_EXCEPTION_MASK);								//clear FPU registers
	NVIC_ClearPendingIRQ(FPU_IRQn);	//	irqresult = NVIC_GetActive(SPIM0_SPIS0_TWIM0_TWIS0_SPI0_TWI0_IRQn);
	//PMAI_twi_uninit();	//nrf_uart_disable(NRF_UART0);
	//nrf_twi_disable(NRF_TWI0);																							//DESSA MSTE VARA MED MEN JAG HAR PROBLEM MED ATT DRA IGNG DEM IGEN
	//nrf_twi_disable(NRF_TWI1);
//clear pending FPU interrupts	
 //irqresult = NVIC_GetPendingIRQ(SPIM0_SPIS0_TWIM0_TWIS0_SPI0_TWI0_IRQn);
 //irqresult = NVIC_GetPendingIRQ(SPIM1_SPIS1_TWIM1_TWIS1_SPI1_TWI1_IRQn);
	//nrf_delay_ms(200);
	__WFE();
	//__SEV();
	__WFE();
	//err_code = sd_app_evt_wait();
	err_code = sd_app_evt_wait();
	err_code = sd_app_evt_wait();
	PMAT_start_timers();
}
void PMPC_sleepMode_15s(void)
{
		ret_code_t err_code;
	PMAIF_LED_Set(ALL_OFF,SOLID);	
	PMAIF_LED_Set(ALL_OFF,SOLID);	
	//HTPA32x32_stopSensor();	
	//PMAIF_StopI2C();								//Put SDA/SCL in right mode
	nrf_delay_ms(100);
	nrf_gpio_cfg_output(PIN_SDA);
	nrf_gpio_cfg_output(PIN_SCL);
	nrf_gpio_pin_set(PIN_SDA);
	nrf_gpio_pin_set(PIN_SCL);

	nrf_gpio_pin_clear(PIN_VCC_HALL);			//Shut down power to HALL sensors
	PMAT_start_15s_timers();
  PMAT_stop_01s_1s_30s_timers();	//stop 0.1s, 1s and 30s timers so they dont trigger any events
	//PMAT_start_15s_timers();
		uint32_t fpscr_reg = __get_FPSCR();	
		__set_FPSCR(fpscr_reg &~FPU_EXCEPTION_MASK);								//clear FPU registers
	NVIC_ClearPendingIRQ(FPU_IRQn);	//	irqresult = NVIC_GetActive(SPIM0_SPIS0_TWIM0_TWIS0_SPI0_TWI0_IRQn);
	//PMAI_twi_uninit();	nrf_uart_disable(NRF_UART0);
//	nrf_twi_disable(NRF_TWI0);																							//DESSA MSTE VARA MED MEN JAG HAR PROBLEM MED ATT DRA IGNG DEM IGEN
//	nrf_twi_disable(NRF_TWI1);
//clear pending FPU interrupts	
//	irqresult = NVIC_GetPendingIRQ(SPIM0_SPIS0_TWIM0_TWIS0_SPI0_TWI0_IRQn);
//	irqresult = NVIC_GetPendingIRQ(SPIM1_SPIS1_TWIM1_TWIS1_SPI1_TWI1_IRQn);
	//nrf_delay_ms(200);

	//__WFE();
__WFE();
	
	err_code = sd_app_evt_wait();
	err_code = sd_app_evt_wait();
	PMAT_start_timers();
}
void PMPC_sleepMode_1s(void)
{
	ret_code_t err_code;
	PMAIF_LED_Set(ALL_OFF,SOLID);	
	PMAIF_LED_Set(ALL_OFF,SOLID);	
	//HTPA32x32_stopSensor();	
	//PMAIF_StopI2C();								//Put SDA/SCL in right mode
	//nrf_gpio_pin_set(PIN_VCC_I2CEN);	//Shutdown power to all I2C units on the bus
		nrf_delay_ms(100);
	nrf_gpio_cfg_output(PIN_SDA);
	nrf_gpio_cfg_output(PIN_SCL);
	nrf_gpio_pin_set(PIN_SDA);
	nrf_gpio_pin_set(PIN_SCL);					//Put SDA/SCL in right mode
	
	nrf_gpio_pin_clear(PIN_VCC_HALL);			//Shut down power to HALL sensors
	PMAT_stop_01s_15s_30s_timers();	//stop 0.1s, 1s and 30s timers so they dont trigger any events
	
		uint32_t fpscr_reg = __get_FPSCR();	
		__set_FPSCR(fpscr_reg &~FPU_EXCEPTION_MASK);								//clear FPU registers
	NVIC_ClearPendingIRQ(FPU_IRQn);	//	irqresult = NVIC_GetActive(SPIM0_SPIS0_TWIM0_TWIS0_SPI0_TWI0_IRQn);
	//PMAI_twi_uninit();	nrf_uart_disable(NRF_UART0);
//	nrf_twi_disable(NRF_TWI0);																							//DESSA MSTE VARA MED MEN JAG HAR PROBLEM MED ATT DRA IGNG DEM IGEN
//	nrf_twi_disable(NRF_TWI1);
//clear pending FPU interrupts	
//irqresult = NVIC_GetPendingIRQ(SPIM0_SPIS0_TWIM0_TWIS0_SPI0_TWI0_IRQn);
//irqresult = NVIC_GetPendingIRQ(SPIM1_SPIS1_TWIM1_TWIS1_SPI1_TWI1_IRQn);
	//nrf_delay_ms(200);
	__WFE();
	//__SEV();
	__WFE();
	
	err_code = sd_app_evt_wait();
	err_code = sd_app_evt_wait();
	PMAT_start_timers();
}

void PMPC_powerMode(void)
{
		//check the hotest temparture and do set readout frequency 
		if(hotestTemperature > TL_OVER_BOILING)
		{
			//DEBUG CODE
			#ifdef DEBUG_MODE
			PMAIF_LED_Set(BLUE,SOLID);
			nrf_delay_ms(100);
			PMAIF_LED_Set(ALL_OFF,SOLID);
			#endif
			
			PMPC_sleepMode_1s();
			powerMode=POWER_MODE_1s;
			sensorReadoutMode = SENSOR_READOUT_NORMAL_MODE;					//Read complete sensor
		}
		else if(hotestTemperature > (TL_STOVE_ON+20))
		{
			//DEBUG CODE
			#ifdef DEBUG_MODE
			PMAIF_LED_Set(BLUE,SOLID);
			nrf_delay_ms(100);
			PMAIF_LED_Set(ALL_OFF,SOLID);
			nrf_delay_ms(100);
			PMAIF_LED_Set(BLUE,SOLID);
			nrf_delay_ms(100);
			PMAIF_LED_Set(ALL_OFF,SOLID);
			#endif
			PMPC_sleepMode_15s();
			powerMode=POWER_MODE_15s;			
			sensorReadoutMode = SENSOR_READOUT_NORMAL_MODE;					//Read complete sensor
		}
		else
		{
			
			//DEBUG CODE
			#ifdef DEBUG_MODE
			PMAIF_LED_Set(BLUE,SOLID);
			nrf_delay_ms(100);
			PMAIF_LED_Set(ALL_OFF,SOLID);
			nrf_delay_ms(100);
			PMAIF_LED_Set(BLUE,SOLID);
			nrf_delay_ms(100);
			PMAIF_LED_Set(ALL_OFF,SOLID);
			nrf_delay_ms(100);
			PMAIF_LED_Set(BLUE,SOLID);
			nrf_delay_ms(100);
			PMAIF_LED_Set(ALL_OFF,SOLID);
			#endif
			
			PMPC_sleepMode_15s();
			powerMode=POWER_MODE_15s;
			sensorReadoutMode = SENSOR_READOUT_POWER_SAVING_MODE;					//Read one of four block eacht round
			
			
			blockToRead++;
			if(blockToRead >3)
				blockToRead = 0;
			
		}
		
			
}


