#include <stdint.h>
#include "m_SensorProcessing.h"
#include "globals.h"
#include "HTPA32x32.h"
#include "m_DebugUART.h"
#include <stdlib.h>

// Tillstnd i SenseStateMachine

#define SS_STARTUP 1
#define SS_NORMAL_OPERATION 2
#define SS_HIGH_POS_DERIV 3
#define SS_HIGH_POS_VALUE 4
#define SS_HIGHALARM 5
#define SS_STOVE_ON 6
#define SS_OVER_BOILING 7
#define SS_MOVEMENT_DETECTED 8



static uint8_t sensestate = SS_STARTUP;

uint8_t SSM_GetState(void)
{
	return sensestate;
}

void SSM_SenseStateMachine(void)
{
	int8_t derivateResult;
	//char resultOfTemperatureAnalysis;
	//static int delayForRapidTemperature;
	/*HTPA32x32_readCompleteSensor();
	PMDEBUG_debugprint_temp();
	PMDEBUG_debugprint_globals();
	
	resultOfTemperatureAnalysis = analyzeTemperature();
	saveTemperatureImage_1s();*/
	switch(sensestate)
	{

// *********************************************************************************************************
		case SS_STARTUP:
			//delayForRapidTemperature=0;
			sensestate = SS_NORMAL_OPERATION;
			SENSESTATE_OUTPUT = TEMP_NORMAL;

		break;

// *********************************************************************************************************
		case SS_NORMAL_OPERATION:
			//delayForRapidTemperature=0;
			/*if(resultOfTemperatureAnalysis == TF_SECOND_LARM_LEVEL)
			{
				TEMPERATURE_STATUS = TEMP_HIGHALARM;
				sensestate = SS_HIGHALARM;
				
			}
			else if(resultOfTemperatureAnalysis == TF_FIRST_LARM_LEVEL)
			{
				TEMPERATURE_STATUS = TEMP_HIGHALARM;
				sensestate = SS_HIGHALARM;
				
			}
			if(resultOfTemperatureAnalysis == TF_OVER_BOILING)
			{
				TEMPERATURE_STATUS = TEMP_OVER_BOILING;
				sensestate = SS_OVER_BOILING;
				
		}*/
		SENSESTATE_OUTPUT = TEMP_NORMAL;
			
		//Undersk om vi har haft en hg derivat i ngon AOI 
		for(int i=0;i<32;i++)
		{
			if(areasOfInterest[i].inUse == true)
			{
				if(areasOfInterest[i].highPositiveDerivate == true)
				{
						areasOfInterest[i].highPositiveDerivate = false;			//we have taken care of the high derivate. Reset so it is not valid next run.
						if(resultOfTemperatureAnalysis >= TF_FIRST_LARM_LEVEL)
							SENSESTATE_OUTPUT = TEMP_HIGH_FAST_RISING;
						else
							SENSESTATE_OUTPUT = TEMP_LOW_FAST_RISING;
						
						sensestate=SS_HIGH_POS_DERIV;
						timer_alarm_delay_running = true;			//Starta timern
						runtime_alarm_delay = 0;						//Nolla tiden.
				}	
	
			}
		}
	
		//Look if we have had high derivates outsides AOI
		if(movementOnStoveFlag == TRUE)
		{
				movementOnStoveFlag = false; 			//we now have taken care of the movement on stove. Reset so it is not valid next run
				if(resultOfTemperatureAnalysis >= TF_FIRST_LARM_LEVEL)
					SENSESTATE_OUTPUT = TEMP_HIGH_FAST_RISING;
				else
					SENSESTATE_OUTPUT = TEMP_LOW_FAST_RISING;
				
				sensestate=SS_HIGH_POS_DERIV;
				timer_alarm_delay_running = true;			//Starta timern
				runtime_alarm_delay = 0;						//Nolla tiden.				
		}
			
		break;
			
// *********************************************************************************************************
		case SS_HIGH_POS_DERIV:
			if(runtime_alarm_delay < (unsigned int) TIMER_ALARM_DELAY_TIMEOUT)
			{
				
						if(runtime_alarm_delay > (TIMER_ALARM_DELAY_TIMEOUT-4))
						{
							if(hotestTemperatureHistogram_10s[9].hotestTemperature > (hotestTemperatureHistogram_10s[0].hotestTemperature+NEGATIVE_DERIVATE_TRESHHOLD))
							{
								derivateResult = abs(hotestTemperatureHistogram_10s[9].xMin-hotestTemperatureHistogram_10s[0].xMin);
									if(derivateResult < LOCATION_TOLERANCE)
									{
										derivateResult = abs(hotestTemperatureHistogram_10s[9].yMin-hotestTemperatureHistogram_10s[0].yMin);
										if(derivateResult < LOCATION_TOLERANCE)
											runtime_alarm_delay = runtime_alarm_delay - 1;
										
										if(resultOfTemperatureAnalysis <= TF_SECOND_LARM_LEVEL)
										{
											timer_alarm_delay_running = FALSE;
											runtime_alarm_delay = 0;
											SENSESTATE_OUTPUT = TEMP_NORMAL;
											sensestate = SS_NORMAL_OPERATION;
										}
									}
								
							}
							
						}
				//TEMPERATURE_STATUS = TEMP_LOW_FAST_RISING;
				//Detta grs nr vi gr till detta tillstnd fr att f en snabbare reaktion
			}
			else
			{
				timer_alarm_delay_running = FALSE;
				runtime_alarm_delay = 0;
				SENSESTATE_OUTPUT = TEMP_NORMAL;
				sensestate = SS_NORMAL_OPERATION;
			}
	
		break;
			
		// *********************************************************************************************************
		case SS_MOVEMENT_DETECTED:
			if(runtime_movement_delay < (unsigned int) TIMER_MOVEMENT_DELAY_TIMEOUT)
			{
				
				SENSESTATE_OUTPUT = MOVEMENT_DETECTED;
			}
			else
			{
				timer_movement_delay_running = FALSE;
				runtime_movement_delay = 0;
				SENSESTATE_OUTPUT = TEMP_NORMAL;
				sensestate = SS_NORMAL_OPERATION;
			}
	
		break;
			
// *********************************************************************************************************
		/*case SS_OVER_BOILING:
			delayForRapidTemperature=0;
			if(resultOfTemperatureAnalysis == TF_SECOND_LARM_LEVEL)
			{
				TEMPERATURE_STATUS = TEMP_HIGHALARM;
				sensestate = SS_HIGHALARM;
				
			}
			else if(resultOfTemperatureAnalysis == TF_OVER_BOILING)
			{
				TEMPERATURE_STATUS = TEMP_OVER_BOILING;
				
				
			}
			else
			{
				TEMPERATURE_STATUS = TEMP_NORMAL;
				sensestate = SS_NORMAL_OPERATION;
			}
			
					//Undersk om vi har haft en hg derivate ngonstans
			for(int i=0;i<32;i++)
			{
				if(areasOfInterest[i].inUse == true)
				{
					if(areasOfInterest[i].highPositiveDerivate == true)
					{
							
							TEMPERATURE_STATUS = TEMP_HIGH_FAST_RISING;
							sensestate=SS_HIGH_POS_DERIV;
					}	
				}
			}
	
		break;
		*/	
//// *********************************************************************************************************
		/*case SS_HIGHALARM:

			if(resultOfTemperatureAnalysis == TF_SECOND_LARM_LEVEL)
			{
				SENSESTATE_STATUS = SS_HIGHALARM;
			
			}
			else if(resultOfTemperatureAnalysis == TF_FIRST_LARM_LEVEL)
			{
				SENSESTATE_STATUS = SS_HIGHALARM;
				
				
			}
			else 
			{
				SENSESTATE_STATUS = TF_OVER_BOILING;
				sensestate = SS_NORMAL_OPERATION;
				
			}	
			
	
		break;
	*/
	} // switch
}
